package lotus.notes;

import java.util.Enumeration;
import java.util.Vector;

public class ACL extends NotesBase {
   private transient Database database;
   private transient Vector entrylist;

   private native int NgetFirstEntry();

   private native int NgetNextEntry(ACLEntry var1);

   private native int NgetEntry(String var1);

   private native void Nsave();

   private native void NrenameRole(String var1, String var2);

   private native void NaddRole(String var1);

   private native void NdeleteRole(String var1);

   private native int NcreateACLEntry(String var1, int var2);

   protected ACL() throws NotesException {
   }

   protected ACL(Database var1, int var2) throws NotesException {
      super(var2, 13);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_db_object"));
      } else {
         this.database = var1;
         this.entrylist = new Vector(3);
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      try {
         Enumeration var4 = this.entrylist.elements();

         while(var4.hasMoreElements()) {
            ACLEntry var1 = (ACLEntry)var4.nextElement();
            super.DestroyObject((NotesBase)var1);
         }
      } catch (Exception var7) {
      } finally {
         this.entrylist.removeAllElements();
         super.finalize();
      }

   }

   public synchronized void finalize() throws NotesException {
      this.database.RemoveObject(this);
      this.InternalFinalize();
   }

   protected void AddEntry(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var2 = this.entrylist;
      synchronized(var2){}

      try {
         this.entrylist.addElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected void RemoveEntry(Object var1) throws NotesException {
      Vector var2 = this.entrylist;
      synchronized(var2){}

      try {
         this.entrylist.removeElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   ACLEntry FindOrCreateEntry(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.entrylist;
         synchronized(var4){}

         ACLEntry var3;
         try {
            Enumeration var6 = this.entrylist.elements();

            ACLEntry var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new ACLEntry(this, var1);
               }

               var2 = (ACLEntry)var6.nextElement();
            } while(!((NotesBase)var2).isEqual(var1));

            var3 = var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   public synchronized void recycle() throws NotesException {
      try {
         this.database.RemoveObject(this);
         Enumeration var4 = this.entrylist.elements();

         while(var4.hasMoreElements()) {
            ACLEntry var1 = (ACLEntry)var4.nextElement();
            super.RecycleObject((NotesBase)var1);
         }
      } catch (NotesException var7) {
      } finally {
         this.entrylist.removeAllElements();
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public ACLEntry getFirstEntry() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      ACLEntry var1;
      try {
         var1 = this.FindOrCreateEntry(this.NgetFirstEntry());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public ACLEntry getNextEntry(ACLEntry var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      ACLEntry var2;
      try {
         var2 = this.FindOrCreateEntry(this.NgetNextEntry(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public ACLEntry getEntry(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      ACLEntry var2;
      try {
         var2 = this.FindOrCreateEntry(this.NgetEntry(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void save() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nsave();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void renameRole(String var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NrenameRole(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void addRole(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NaddRole(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void deleteRole(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NdeleteRole(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public ACLEntry createACLEntry(String var1, int var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      ACLEntry var3;
      try {
         var3 = this.FindOrCreateEntry(this.NcreateACLEntry(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Vector getRoles() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var2;
      try {
         String[] var5 = ((NotesBase)this).PropGetStringArray(1400);
         Vector var1;
         if (var5 != null && var5.length > 0) {
            var1 = new Vector(var5.length, 1);

            for(int var6 = 0; var6 < var5.length; ++var6) {
               var1.addElement(var5[var6]);
            }
         } else {
            var1 = new Vector(1);
         }

         var2 = var1;
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public Database getParent() throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.database;
   }

   public boolean isUniformAccess() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1423);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setUniformAccess(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1423, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }
}
