package lotus.notes;

public class Agent extends NotesBase {
   private transient Database database;

   private native int Nrun(boolean var1);

   private native void Nremove();

   private native void Nsave();

   protected Agent() throws NotesException {
   }

   protected Agent(Database var1, int var2) throws NotesException {
      super(var2, 9);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_db_object"));
      } else {
         this.database = var1;
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.database.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.database.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.finalize();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public void run() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nrun(false);
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public int runOnServer() throws NotesException {
      int var1 = 0;
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         var1 = this.Nrun(true);
      } catch (Throwable var4) {
         throw var4;
      }

      return var1;
   }

   public void remove() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nremove();
         this.database.RemoveObject(this);
         super.cpp_object = 0;
         this.finalize();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void save() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nsave();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public String getName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1110);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public String getOwner() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1111);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public DateTime getLastRun() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.database.getParent().FindOrCreateDateTime(((NotesBase)this).PropGetDate(1112));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isEnabled() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1113);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setEnabled(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1113, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getServerName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1114);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setServerName(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1114, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getQuery() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1115);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getComment() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1116);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Database getParent() throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.database;
   }

   public boolean isPublic() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1118);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getCommonOwner() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1119);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }
}
