package lotus.notes;

import java.io.PrintStream;
import java.io.PrintWriter;
import lotus.notes.internal.AgentOutputStream;

public class AgentBase extends NotesThread {
   private boolean m_debug = false;
   private AgentInfo m_ai;
   private PrintWriter m_agentOutput;
   protected Session m_session;

   private static ThreadGroup getUserThreadGroup() {
      AgentThreadGroup var0 = NotesThread.getAgentThreadGroup();
      return var0 != null ? var0.getUserThreadGroup() : null;
   }

   private static String getAgentName() {
      AgentThreadGroup var0 = NotesThread.getAgentThreadGroup();
      return var0 != null ? var0.getAgentName() : "???";
   }

   public AgentBase() {
      super(getUserThreadGroup(), "AgentThread: " + getAgentName());
   }

   public final void startup(AgentInfo var1) {
      try {
         this.m_ai = var1;
         this.dbgMsg("m_restricted = " + this.m_ai.isRestricted());
         this.dbgMsg("m_timeout    = " + this.m_ai.getTimeout());
         ((Thread)this).start();
      } catch (Exception var3) {
         System.err.println(JavaString.resource.getString("agent_base_error") + " " + var3);
         ((Throwable)var3).printStackTrace(System.err);
      } catch (Error var4) {
         System.err.println(JavaString.resource.getString("agent_base_error") + " " + var4);
         ((Throwable)var4).printStackTrace(System.err);
      }
   }

   public final void runNotes() throws NotesException {
      this.dbgMsg("Inside AgentBase.runNotes()...");
      this.m_session = this.m_ai.getSession();
      this.dbgMsg("m_session = " + this.m_ai.getSession());
      this.NotesMain();
   }

   public void NotesMain() {
   }

   public Session getSession() {
      return this.m_session;
   }

   public boolean isRestricted() {
      return this.m_ai.isRestricted();
   }

   public PrintWriter getAgentOutput() {
      if (this.m_agentOutput == null) {
         this.m_agentOutput = AgentOutputStream.getAgentOutput(this.m_ai.redirectAgentOutput(), this.m_ai.getDocID());
      }

      return this.m_agentOutput;
   }

   public void setDebug(boolean var1) {
      this.m_debug = var1;
   }

   public void setTrace(boolean var1) {
      Runtime.getRuntime().traceMethodCalls(var1);
   }

   public void dbgMsg(String var1, PrintStream var2) {
      if (this.m_debug) {
         var2.println("dbg: " + var1);
      }

   }

   public void dbgMsg(String var1, PrintWriter var2) {
      if (this.m_debug) {
         var2.println("dbg: " + var1);
      }

   }

   public void dbgMsg(String var1) {
      if (this.m_debug) {
         this.dbgMsg(var1, System.out);
      }

   }
}
