package lotus.notes;

public class AgentContext extends NotesBase {
   private transient Session session;
   private transient Document contextdoc;
   private transient Document saveddata;

   private native void NupdateProcessedDoc(Document var1);

   private native int NunprocessedFTSearch(String var1, int var2, int var3, int var4);

   private native int NunprocessedSearch(String var1, DateTime var2, int var3);

   public AgentContext() throws NotesException {
   }

   protected AgentContext(Session var1, int var2) throws NotesException {
      super(var2, 23);
      this.session = var1;
      var1.AddObject(this);
   }

   protected void InternalFinalize() throws NotesException {
      this.saveddata = null;
      this.contextdoc = null;
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.session.RemoveObject(this);
      this.InternalFinalize();
   }

   public void updateProcessedDoc(Document var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NupdateProcessedDoc(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public DocumentCollection unprocessedFTSearch(String var1, int var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      Database var3 = this.getCurrentDatabase();
      if (var3 != null) {
         synchronized(this){}

         DocumentCollection var4;
         try {
            var4 = var3.FindOrCreateDocCollection(this.NunprocessedFTSearch(var1, var2, 0, 0));
         } catch (Throwable var8) {
            throw var8;
         }

         return var4;
      } else {
         return null;
      }
   }

   public DocumentCollection unprocessedFTSearch(String var1, int var2, int var3, int var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      Database var5 = this.getCurrentDatabase();
      if (var5 != null) {
         synchronized(this){}

         DocumentCollection var6;
         try {
            var6 = var5.FindOrCreateDocCollection(this.NunprocessedFTSearch(var1, var2, var3, var4));
         } catch (Throwable var10) {
            throw var10;
         }

         return var6;
      } else {
         return null;
      }
   }

   public DocumentCollection unprocessedSearch(String var1, DateTime var2, int var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      Database var4 = this.getCurrentDatabase();
      if (var4 != null) {
         synchronized(this){}

         DocumentCollection var5;
         try {
            var5 = var4.FindOrCreateDocCollection(this.NunprocessedSearch(var1, var2, var3));
         } catch (Throwable var9) {
            throw var9;
         }

         return var5;
      } else {
         return null;
      }
   }

   public String getEffectiveUserName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1850);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getEffectiveUserName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public Agent getCurrentAgent() throws NotesException {
      Object var1 = null;
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Agent var2;
      try {
         int var5 = ((NotesBase)this).PropGetAdt(1851);
         Agent var9 = (Agent)this.session.FindObject(var5);
         if (var9 == null) {
            Database var6 = this.getCurrentDatabase();
            if (var6 != null) {
               var9 = new Agent(var6, var5);
            }
         }

         var2 = var9;
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public Database getCurrentDatabase() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var1;
      try {
         int var4 = ((NotesBase)this).PropGetAdt(1852);
         var1 = this.session.FindOrCreateDatabase(var4);
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public Document getDocumentContext() throws NotesException {
      ((NotesBase)this).CheckObject();
      if (this.contextdoc == null) {
         synchronized(this){}

         try {
            int var3 = ((NotesBase)this).PropGetAdt(1853);
            if (var3 != 0) {
               this.contextdoc = new Document(this.session, var3);
            }
         } catch (Throwable var5) {
            throw var5;
         }
      }

      return this.contextdoc;
   }

   public int getLastExitStatus() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1854);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public DateTime getLastRun() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.session.FindOrCreateDateTime(((NotesBase)this).PropGetDate(1855));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Document getSavedData() throws NotesException {
      ((NotesBase)this).CheckObject();
      if (this.saveddata == null) {
         synchronized(this){}

         try {
            int var3 = ((NotesBase)this).PropGetAdt(1856);
            Database var4 = this.getCurrentDatabase();
            this.saveddata = new Document(var4, var3);
         } catch (Throwable var6) {
            throw var6;
         }
      }

      return this.saveddata;
   }

   public DocumentCollection getUnprocessedDocuments() throws NotesException {
      ((NotesBase)this).CheckObject();
      Database var1 = this.getCurrentDatabase();
      synchronized(this){}

      DocumentCollection var2;
      try {
         int var5 = ((NotesBase)this).PropGetAdt(1857);
         var2 = var1.FindOrCreateDocCollection(var5);
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }
}
