package lotus.notes;

public final class AgentThreadGroup extends ThreadGroup {
   private String agentName;
   private ThreadGroup userThreadGroup;
   private int activeNotesThreadCount;
   private int staticActiveNotesThreadCount;

   public AgentThreadGroup(String var1) {
      super("ATG: " + var1);
      this.agentName = var1;
      this.userThreadGroup = new ThreadGroup(this, "UTG: " + var1);
   }

   public ThreadGroup getUserThreadGroup() {
      return this.userThreadGroup;
   }

   public String getAgentName() {
      return this.agentName;
   }

   public int getActiveNotesThreadCount() {
      return this.activeNotesThreadCount;
   }

   public void bumpActiveNotesThreadCount(int var1) {
      synchronized(this){}

      try {
         this.activeNotesThreadCount += var1;
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getStaticActiveNotesThreadCount() {
      return this.staticActiveNotesThreadCount;
   }

   public void bumpStaticActiveNotesThreadCount(int var1) {
      synchronized(this){}

      try {
         this.staticActiveNotesThreadCount += var1;
      } catch (Throwable var4) {
         throw var4;
      }

   }
}
