package lotus.notes;

public class DateTime extends NotesBase {
   transient Session session;

   private native void NadjustTime(boolean var1, int var2, int var3, int var4, int var5, int var6, int var7);

   private native void NconvertToZone(int var1, boolean var2);

   private native void NsetAnyDate();

   private native void NsetAnyTime();

   private native void NsetNow();

   private native int NtimeDifference(DateTime var1);

   private native void NsetLocalTime(int var1, int var2, int var3, int var4);

   private native void NsetLocalDate(int var1, int var2, int var3, boolean var4);

   protected DateTime(int var1) throws NotesException {
      super(var1, 8);
   }

   protected DateTime(Session var1, int var2, String var3) throws NotesException {
      super(var2, 8);
      this.session = var1;
      var1.AddObject(this);
   }

   protected DateTime(Session var1, int var2) throws NotesException {
      super(var2, 8);
      this.session = var1;
      var1.AddObject(this);
   }

   public void recycle() throws NotesException {
      try {
         this.session.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public void adjustHour(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustHour(var1, false);
   }

   public void adjustHour(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, 0, 0, 0, var1, 0, 0);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void adjustMinute(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustMinute(var1, false);
   }

   public void adjustMinute(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, 0, 0, 0, 0, var1, 0);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void adjustSecond(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustSecond(var1, false);
   }

   public void adjustSecond(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, 0, 0, 0, 0, 0, var1);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void adjustDay(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustDay(var1, false);
   }

   public void adjustDay(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, 0, 0, var1, 0, 0, 0);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void adjustMonth(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustMonth(var1, false);
   }

   public void adjustMonth(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, 0, var1, 0, 0, 0, 0);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void adjustYear(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.adjustYear(var1, false);
   }

   public void adjustYear(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NadjustTime(var2, var1, 0, 0, 0, 0, 0);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void convertToZone(int var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NconvertToZone(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void setAnyDate() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetAnyDate();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void setAnyTime() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetAnyTime();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void setNow() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetNow();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public int timeDifference(DateTime var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var2;
      try {
         var2 = this.NtimeDifference(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void setLocalDate(int var1, int var2, int var3, boolean var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetLocalDate(var1, var2, var3, var4);
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public void setLocalTime(int var1, int var2, int var3, int var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetLocalTime(var1, var2, var3, var4);
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public String getGMTTime() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1261);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isDST() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1265);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getLocalTime() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1260);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getLocalTime();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public void setLocalTime(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1260, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getTimeZone() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1264);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getZoneTime() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1278);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getDateOnly() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1279);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getTimeOnly() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1900);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }
}
