package lotus.notes;

public class DbDirectory extends NotesBase {
   private transient Session session;
   public static final int REPLICA_CANDIDATE = 1245;
   public static final int TEMPLATE_CANDIDATE = 1246;
   public static final int DATABASE = 1247;
   public static final int TEMPLATE = 1248;

   private native int NgetFirstDatabase(int var1);

   private native int NgetNextDatabase();

   private native int NcreateDatabase(String var1, boolean var2);

   private native int NopenDatabase(String var1, boolean var2);

   private native int NopenDatabaseIfModified(String var1, DateTime var2);

   private static synchronized native int NopenMailDatabase(Session var0);

   private native int NopenDatabaseByReplicaID(String var1);

   protected DbDirectory() throws NotesException {
   }

   protected DbDirectory(Session var1, int var2) throws NotesException {
      super(var2, 10);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_session_object"));
      } else {
         this.session = var1;
         var1.AddObject(this);
      }
   }

   protected DbDirectory(Session var1, int var2, String var3) throws NotesException {
      super(var2, 10);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_session_object"));
      } else {
         this.session = var1;
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.session.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.session.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public Database getFirstDatabase(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var2;
      try {
         var2 = this.session.FindOrCreateDatabase(this.NgetFirstDatabase(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Database getNextDatabase() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var1;
      try {
         var1 = this.session.FindOrCreateDatabase(this.NgetNextDatabase());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Database createDatabase(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var2;
      try {
         var2 = this.createDatabase(var1, true);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Database createDatabase(String var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var3;
      try {
         var3 = this.session.FindOrCreateDatabase(this.NcreateDatabase(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Database openDatabase(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var2;
      try {
         var2 = this.openDatabase(var1, false);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Database openDatabase(String var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var3;
      try {
         var3 = this.session.FindOrCreateDatabase(this.NopenDatabase(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Database openDatabaseIfModified(String var1, DateTime var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var3;
      try {
         var3 = this.session.FindOrCreateDatabase(this.NopenDatabaseIfModified(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public static Database openMailDatabase(Session var0) throws NotesException {
      return var0.FindOrCreateDatabase(NopenMailDatabase(var0));
   }

   public Database openDatabaseByReplicaID(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var2;
      try {
         var2 = this.session.FindOrCreateDatabase(this.NopenDatabaseByReplicaID(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public String getName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1240);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }
}
