package lotus.notes;

import java.util.Enumeration;
import java.util.Vector;

public class Document extends NotesBase {
   private transient Database database;
   private transient Vector itemlist;
   private transient Vector eolist;

   private native int NappendItemValue(String var1, Object var2);

   private native boolean NcomputeWithForm(boolean var1, boolean var2);

   private native void NcopyAllItems(Document var1, boolean var2);

   private native int NcopyItem(Item var1, String var2);

   private native int NcopyToDatabase(Database var1);

   private native int NcreateRichTextItem(String var1);

   private native int NcreateReplyMessage(boolean var1);

   private native void Nencrypt();

   private native int NgetFirstItem(String var1);

   private native Vector NgetItemValue(String var1);

   private native String NgetItemValueString(String var1);

   private native int NgetItemValueInteger(String var1);

   private native double NgetItemValueDouble(String var1);

   private native boolean NhasItem(String var1);

   private native void NmakeResponse(Document var1);

   private native void NputInFolder(String var1);

   private native boolean Nremove(boolean var1);

   private native void NremoveFromFolder(String var1);

   private native void NremoveItem(String var1);

   private native boolean NrenderToRTItem(RichTextItem var1);

   private native int NreplaceItemValue(String var1, Object var2);

   private native boolean Nsave(boolean var1, boolean var2, boolean var3);

   private native void Nsend(boolean var1, Vector var2);

   private native void Nsign();

   private native int NgetAttachment(String var1);

   protected Document() throws NotesException {
   }

   protected Document(Session var1, int var2) throws NotesException {
      super(var2, 4);
      this.itemlist = new Vector(3);
      this.eolist = new Vector(3);
      int var3 = ((NotesBase)this).PropGetAdt(1152);
      this.database = var1.FindOrCreateDatabase(var3);
   }

   protected Document(Database var1, int var2) throws NotesException {
      super(var2, 4);
      this.database = var1;
      this.itemlist = new Vector(3);
      this.eolist = new Vector(3);
      var1.AddDocument(this);
   }

   public void recycle() throws NotesException {
      try {
         this.database.RemoveDocument(this);
         Vector var6 = this.itemlist;
         synchronized(var6){}

         try {
            Enumeration var3 = this.itemlist.elements();

            while(var3.hasMoreElements()) {
               NotesBase var1 = (NotesBase)var3.nextElement();
               super.RecycleObject(var1);
            }
         } catch (Throwable var62) {
            throw var62;
         }

         var6 = this.eolist;
         synchronized(var6){}

         try {
            Enumeration var65 = this.eolist.elements();

            while(var65.hasMoreElements()) {
               NotesBase var2 = (NotesBase)var65.nextElement();
               super.RecycleObject(var2);
            }
         } catch (Throwable var61) {
            throw var61;
         }
      } catch (NotesException var63) {
      } finally {
         if (this.itemlist != null) {
            Vector var67 = this.itemlist;
            synchronized(var67){}

            try {
               this.itemlist.removeAllElements();
               this.itemlist = null;
            } catch (Throwable var60) {
               throw var60;
            }
         }

         if (this.eolist != null) {
            Vector var68 = this.eolist;
            synchronized(var68){}

            try {
               this.eolist.removeAllElements();
               this.eolist = null;
            } catch (Throwable var59) {
               throw var59;
            }
         }

         super.Recycle();
      }

   }

   protected void InternalFinalize() throws NotesException {
      try {
         Vector var6 = this.itemlist;
         synchronized(var6){}

         try {
            Enumeration var3 = this.itemlist.elements();

            while(var3.hasMoreElements()) {
               NotesBase var1 = (NotesBase)var3.nextElement();
               super.DestroyObject(var1);
            }
         } catch (Throwable var62) {
            throw var62;
         }

         var6 = this.eolist;
         synchronized(var6){}

         try {
            Enumeration var65 = this.eolist.elements();

            while(var65.hasMoreElements()) {
               NotesBase var2 = (NotesBase)var65.nextElement();
               super.DestroyObject(var2);
            }
         } catch (Throwable var61) {
            throw var61;
         }
      } catch (Exception var63) {
      } finally {
         if (this.itemlist != null) {
            Vector var67 = this.itemlist;
            synchronized(var67){}

            try {
               this.itemlist.removeAllElements();
               this.itemlist = null;
            } catch (Throwable var60) {
               throw var60;
            }
         }

         if (this.eolist != null) {
            Vector var68 = this.eolist;
            synchronized(var68){}

            try {
               this.eolist.removeAllElements();
               this.eolist = null;
            } catch (Throwable var59) {
               throw var59;
            }
         }

         super.finalize();
      }

   }

   public void finalize() throws NotesException {
      this.database.RemoveDocument(this);
      this.InternalFinalize();
   }

   protected void AddItem(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var2 = this.itemlist;
      synchronized(var2){}

      try {
         this.itemlist.addElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected void RemoveItem(Object var1) throws NotesException {
      if (this.itemlist != null) {
         Vector var2 = this.itemlist;
         synchronized(var2){}

         try {
            this.itemlist.removeElement(var1);
         } catch (Throwable var4) {
            throw var4;
         }

      }
   }

   protected Item FindOrCreateItem(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var3 = this.itemlist;
         synchronized(var3){}

         try {
            Enumeration var5 = this.itemlist.elements();

            while(var5.hasMoreElements()) {
               Item var6 = (Item)var5.nextElement();
               if (((NotesBase)var6).isEqual(var1)) {
                  Item var2 = var6;
                  return var2;
               }
            }
         } catch (Throwable var8) {
            throw var8;
         }

         int var9 = ((NotesBase)this).ObjectClass(var1);
         if (var9 == 5) {
            return new Item(this, var1);
         } else if (var9 == 6) {
            return new RichTextItem(this, var1);
         } else {
            throw new NotesException(JavaString.resource.getString("not_rich_text"));
         }
      }
   }

   protected RichTextItem FindOrCreateRTItem(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var3 = this.itemlist;
         synchronized(var3){}

         RichTextItem var2;
         try {
            Enumeration var5 = this.itemlist.elements();

            Item var6;
            do {
               if (!var5.hasMoreElements()) {
                  return new RichTextItem(this, var1);
               }

               var6 = (Item)var5.nextElement();
            } while(!((NotesBase)var6).isEqual(var1));

            var2 = (RichTextItem)var6;
         } catch (Throwable var8) {
            throw var8;
         }

         return var2;
      }
   }

   protected void AddEmbedded(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var2 = this.eolist;
      synchronized(var2){}

      try {
         this.eolist.addElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected void RemoveEmbedded(Object var1) throws NotesException {
      if (this.eolist != null) {
         Vector var2 = this.eolist;
         synchronized(var2){}

         try {
            this.eolist.removeElement(var1);
         } catch (Throwable var4) {
            throw var4;
         }

      }
   }

   protected EmbeddedObject FindOrCreateEmbedded(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var3 = this.eolist;
         synchronized(var3){}

         EmbeddedObject var2;
         try {
            Enumeration var5 = this.eolist.elements();

            EmbeddedObject var6;
            do {
               if (!var5.hasMoreElements()) {
                  return new EmbeddedObject(this, var1);
               }

               var6 = (EmbeddedObject)var5.nextElement();
            } while(!((NotesBase)var6).isEqual(var1));

            var2 = var6;
         } catch (Throwable var8) {
            throw var8;
         }

         return var2;
      }
   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public Item appendItemValue(String var1, Object var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Item var3;
      try {
         var3 = this.FindOrCreateItem(this.NappendItemValue(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Item appendItemValue(String var1) throws NotesException {
      return this.appendItemValue(var1, (Object)null);
   }

   public Item appendItemValue(String var1, int var2) throws NotesException {
      return this.appendItemValue(var1, new Integer(var2));
   }

   public Item appendItemValue(String var1, double var2) throws NotesException {
      return this.appendItemValue(var1, new Double(var2));
   }

   public boolean computeWithForm(boolean var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var3;
      try {
         var3 = this.NcomputeWithForm(var1, var2);
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public void copyAllItems(Document var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NcopyAllItems(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public Item copyItem(Item var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Item var3;
      try {
         var3 = this.FindOrCreateItem(this.NcopyItem(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Item copyItem(Item var1) throws NotesException {
      return this.copyItem(var1, (String)null);
   }

   public Document copyToDatabase(Database var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         var2 = var1.FindOrCreateDocument(this.NcopyToDatabase(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public RichTextItem createRichTextItem(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      RichTextItem var2;
      try {
         var2 = this.FindOrCreateRTItem(this.NcreateRichTextItem(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Document createReplyMessage(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         var2 = this.database.FindOrCreateDocument(this.NcreateReplyMessage(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void encrypt() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nencrypt();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public Item getFirstItem(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Item var2;
      try {
         var2 = this.FindOrCreateItem(this.NgetFirstItem(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Vector getItemValue(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var2;
      try {
         var2 = this.NgetItemValue(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public String getItemValueString(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var2;
      try {
         var2 = this.NgetItemValueString(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public int getItemValueInteger(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var2;
      try {
         var2 = this.NgetItemValueInteger(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public double getItemValueDouble(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      double var2;
      try {
         var2 = this.NgetItemValueDouble(var1);
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public boolean hasItem(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var2;
      try {
         var2 = this.NhasItem(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void makeResponse(Document var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NmakeResponse(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void putInFolder(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NputInFolder(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean remove(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var2;
      try {
         boolean var5 = this.Nremove(var1);
         this.database.RemoveDocument(this);
         this.finalize();
         var2 = var5;
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public void removeFromFolder(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NremoveFromFolder(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void removeItem(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NremoveItem(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean renderToRTItem(RichTextItem var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var2;
      try {
         var2 = this.NrenderToRTItem(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Item replaceItemValue(String var1, Object var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Item var3;
      try {
         var3 = this.FindOrCreateItem(this.NreplaceItemValue(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public boolean save(boolean var1, boolean var2, boolean var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var4;
      try {
         var4 = this.Nsave(var1, var2, var3);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public boolean save(boolean var1, boolean var2) throws NotesException {
      return this.save(var1, var2, false);
   }

   public boolean save(boolean var1) throws NotesException {
      return this.save(var1, false, false);
   }

   public boolean save() throws NotesException {
      return this.save(false, false, false);
   }

   public void send(boolean var1, Vector var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nsend(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void send(Vector var1) throws NotesException {
      this.send(false, var1);
   }

   public void send(boolean var1, String var2) throws NotesException {
      Vector var3 = new Vector(1);
      var3.addElement(var2);
      this.send(var1, var3);
   }

   public void send(String var1) throws NotesException {
      Vector var2 = new Vector(1);
      var2.addElement(var1);
      this.send(false, var2);
   }

   public void sign() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nsign();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public EmbeddedObject getAttachment(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      EmbeddedObject var2;
      try {
         var2 = this.FindOrCreateEmbedded(this.NgetAttachment(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public String getNoteID() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1148);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getParentDocumentUNID() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1154);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getSigner() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1158);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getUniversalID() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1149);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getUniversalID();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public void setUniversalID(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1149, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getVerifier() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1159);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isEncryptOnSend() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1155);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setEncryptOnSend(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1155, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean hasEmbedded() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1151);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isNewNote() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1146);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isResponse() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1144);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isSigned() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1140);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isSaveMessageOnSend() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1157);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSaveMessageOnSend(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1157, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isSentByAgent() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1162);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isSignOnSend() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1156);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSignOnSend(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1156, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public Vector getAuthors() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var2;
      try {
         String[] var5 = ((NotesBase)this).PropGetStringArray(1147);
         Vector var1;
         if (var5 != null && var5.length > 0) {
            var1 = new Vector(var5.length, 1);

            for(int var6 = 0; var6 < var5.length; ++var6) {
               var1.addElement(var5[var6]);
            }
         } else {
            var1 = new Vector(1);
         }

         var2 = var1;
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public Vector getColumnValues() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var1;
      try {
         var1 = ((NotesBase)this).PropGetVector(1164);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Vector getEmbeddedObjects() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var1;
      try {
         int[] var4 = ((NotesBase)this).PropGetObjArray(2950);
         if (var4.length != 0) {
            Vector var7 = new Vector(var4.length);

            for(int var6 = 0; var6 < var4.length; ++var6) {
               EmbeddedObject var5 = this.FindOrCreateEmbedded(var4[var6]);
               var7.addElement(var5);
            }

            var1 = var7;
            return var1;
         }

         var1 = null;
      } catch (Throwable var9) {
         throw var9;
      }

      return var1;
   }

   public Vector getEncryptionKeys() throws NotesException {
      Vector var1 = new Vector();
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         String[] var4 = ((NotesBase)this).PropGetStringArray(1161);
         if (var4 != null && var4.length > 0) {
            for(int var5 = 0; var5 < var4.length; ++var5) {
               var1.addElement(var4[var5]);
            }
         }
      } catch (Throwable var7) {
         throw var7;
      }

      return var1;
   }

   public void setEncryptionKeys(Vector var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetVector(1161, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public Vector getItems() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var1;
      try {
         int[] var4 = ((NotesBase)this).PropGetObjArray(1150);
         if (var4.length != 0) {
            Vector var7 = new Vector(var4.length);

            for(int var6 = 0; var6 < var4.length; ++var6) {
               Item var5 = this.FindOrCreateItem(var4[var6]);
               var7.addElement(var5);
            }

            var1 = var7;
            return var1;
         }

         var1 = null;
      } catch (Throwable var9) {
         throw var9;
      }

      return var1;
   }

   public DateTime getCreated() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.database.getParent().FindOrCreateDateTime(((NotesBase)this).PropGetDate(1143));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public DateTime getLastAccessed() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.database.getParent().FindOrCreateDateTime(((NotesBase)this).PropGetDate(1142));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public DateTime getLastModified() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.database.getParent().FindOrCreateDateTime(((NotesBase)this).PropGetDate(1141));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Database getParentDatabase() throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.database;
   }

   public int getFTSearchScore() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1145);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int getSize() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1163);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public View getParentView() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      View var1;
      try {
         int var4 = ((NotesBase)this).PropGetAdt(1153);
         if (var4 == 0) {
            var1 = null;
            return var1;
         }

         var1 = this.database.FindOrCreateView(var4);
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public DocumentCollection getResponses() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DocumentCollection var1;
      try {
         var1 = this.database.FindOrCreateDocCollection(((NotesBase)this).PropGetAdt(1160));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isProfile() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(2952);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getNameOfProfile() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(2953);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getKey() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(2954);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }
}
