package lotus.notes;

public class DocumentCollection extends NotesBase {
   private transient Database database;

   private native int NgetFirstDocument();

   private native int NgetLastDocument();

   private native int NgetNextDocument(Document var1);

   private native int NgetPrevDocument(Document var1);

   private native int NgetNthDocument(int var1);

   private native void NFTSearch(String var1, int var2);

   private native void NremoveAll(boolean var1);

   private native void NupdateAll();

   private native void NstampAll(String var1, Object var2);

   private native void NputAllInFolder(String var1);

   private native void NremoveAllFromFolder(String var1);

   protected DocumentCollection() throws NotesException {
   }

   protected DocumentCollection(Database var1, int var2) throws NotesException {
      super(var2, 11);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_db_object"));
      } else {
         this.database = var1;
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.database.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.database.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public Document getFirstDocument() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var1;
      try {
         var1 = this.database.FindOrCreateDocument(this.NgetFirstDocument());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Document getLastDocument() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var1;
      try {
         var1 = this.database.FindOrCreateDocument(this.NgetLastDocument());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Document getNextDocument(Document var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         var2 = this.database.FindOrCreateDocument(this.NgetNextDocument(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Document getPrevDocument(Document var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         var2 = this.database.FindOrCreateDocument(this.NgetPrevDocument(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Document getNthDocument(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         var2 = this.database.FindOrCreateDocument(this.NgetNthDocument(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void FTSearch(String var1, int var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NFTSearch(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void removeAll(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         Document var5;
         for(Document var4 = this.getFirstDocument(); var4 != null; var4 = var5) {
            var5 = this.getNextDocument(var4);
            var4.finalize();
         }

         this.NremoveAll(var1);
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public void updateAll() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NupdateAll();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void stampAll(String var1, Object var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NstampAll(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void putAllInFolder(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NputAllInFolder(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void removeAllFromFolder(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NremoveAllFromFolder(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getCount() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1330);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isSorted() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1331);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getQuery() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1332);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public Database getParent() throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.database;
   }
}
