package lotus.notes;

import java.util.Vector;

public class EmbeddedObject extends NotesBase {
   private transient Document parent;
   public static final int EMBED_OBJECTLINK = 1452;
   public static final int EMBED_OBJECT = 1453;
   public static final int EMBED_ATTACHMENT = 1454;

   private native int Nactivate(boolean var1);

   public native void NextractFile(String var1);

   public native void NdoVerb(String var1);

   public native void Nremove();

   protected EmbeddedObject() throws NotesException {
   }

   protected EmbeddedObject(Document var1, int var2) throws NotesException {
      super(var2, 16);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_document_object"));
      } else {
         this.parent = var1;
         var1.AddEmbedded(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.parent.RemoveEmbedded(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.parent.RemoveEmbedded(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public int activate(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var2;
      try {
         var2 = this.Nactivate(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public void extractFile(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NextractFile(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void doVerb(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NdoVerb(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void remove() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nremove();
         this.parent.RemoveEmbedded(this);
         super.cpp_object = 0;
         this.finalize();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public String getName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1440);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public String getClassName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1441);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getSource() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1442);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int getType() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1443);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int getFileSize() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1444);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public RichTextItem getParent() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      RichTextItem var1;
      try {
         int var4 = ((NotesBase)this).PropGetAdt(1445);
         var1 = (RichTextItem)this.parent.FindOrCreateItem(var4);
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public Vector getVerbs() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var2;
      try {
         String[] var5 = ((NotesBase)this).PropGetStringArray(1446);
         Vector var1;
         if (var5 != null && var5.length > 0) {
            var1 = new Vector(var5.length, 1);

            for(int var6 = 0; var6 < var5.length; ++var6) {
               var1.addElement(var5[var6]);
            }
         } else {
            var1 = new Vector(1);
         }

         var2 = var1;
      } catch (Throwable var8) {
         throw var8;
      }

      return var2;
   }

   public int getObject() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1447);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }
}
