package lotus.notes;

import java.util.Vector;

public class Item extends NotesBase {
   protected transient Document parent;
   private static final int CLASS_NOCOMPUTE = 0;
   private static final int CLASS_ERROR = 256;
   private static final int CLASS_UNAVAILABLE = 512;
   private static final int CLASS_NUMBER = 768;
   private static final int CLASS_TIME = 1024;
   private static final int CLASS_TEXT = 1280;
   private static final int CLASS_FORMULA = 1536;
   private static final int CLASS_USERID = 1792;
   static final int CNOTES_ICONST_NAMES = 1074;
   static final int CNOTES_ICONST_READERS = 1075;
   static final int CNOTES_ICONST_AUTHORS = 1076;
   static final int CNOTES_ICONST_ATTACHMENT = 1084;
   static final int CNOTES_ICONST_OTHEROBJECT = 1085;
   static final int CNOTES_ICONST_EMBEDDEDOBJ = 1090;
   public static final int ERRORITEM = 256;
   public static final int UNAVAILABLE = 512;
   public static final int TEXT = 1280;
   public static final int NUMBERS = 768;
   public static final int DATETIMES = 1024;
   public static final int NAMES = 1074;
   public static final int READERS = 1075;
   public static final int AUTHORS = 1076;
   public static final int RICHTEXT = 1;
   public static final int USERID = 1792;
   public static final int FORMULA = 1536;
   public static final int COLLATION = 2;
   public static final int NOTEREFS = 4;
   public static final int NOTELINKS = 7;
   public static final int ATTACHMENT = 1084;
   public static final int OTHEROBJECT = 1085;
   public static final int UNKNOWN = 0;
   public static final int ICON = 6;
   public static final int SIGNATURE = 8;
   public static final int USERDATA = 14;
   public static final int EMBEDDEDOBJECT = 1090;
   public static final int QUERYCD = 15;
   public static final int ACTIONCD = 16;
   public static final int ASSISTANTINFO = 17;
   public static final int VIEWMAPDATA = 18;
   public static final int VIEWMAPLAYOUT = 19;
   public static final int LSOBJECT = 20;
   public static final int HTML = 21;

   private native String NabstractText(int var1, boolean var2, boolean var3);

   private native void NappendToTextList(Vector var1);

   private native boolean NcontainsValue(Object var1);

   private native int NcopyItemToDocument(Document var1, String var2);

   private native void Nremove();

   protected Item() throws NotesException {
   }

   protected Item(Document var1, int var2) throws NotesException {
      super(var2, 5);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_document_object"));
      } else {
         this.parent = var1;
         this.parent.AddItem(this);
      }
   }

   protected Item(int var1, int var2) throws NotesException {
      super(var1, var2);
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.parent.RemoveItem(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.parent.RemoveItem(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public String abstractText(int var1, boolean var2, boolean var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var4;
      try {
         var4 = this.NabstractText(var1, var2, var3);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public void appendToTextList(Vector var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NappendToTextList(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void appendToTextList(String var1) throws NotesException {
      Vector var2 = new Vector(1);
      var2.addElement(var1);
      this.appendToTextList(var2);
   }

   public boolean containsValue(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var2;
      try {
         var2 = this.NcontainsValue(var1);
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Item copyItemToDocument(Document var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Item var3;
      try {
         var3 = this.parent.FindOrCreateItem(this.NcopyItemToDocument(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Item copyItemToDocument(Document var1) throws NotesException {
      return this.copyItemToDocument(var1, (String)null);
   }

   public void remove() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nremove();
         this.parent.RemoveItem(this);
         super.cpp_object = 0;
         this.finalize();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public boolean isAuthors() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1062);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setAuthors(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1062, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isEncrypted() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1054);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setEncrypted(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1054, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isNames() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1060);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setNames(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1060, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isProtected() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1057);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setProtected(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1057, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isReaders() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1061);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setReaders(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1061, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isSigned() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1055);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSigned(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1055, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isSummary() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1056);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSummary(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1056, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public DateTime getDateTimeValue() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var2;
      try {
         int var1 = ((NotesBase)this).PropGetAdt(1063);
         Session var5 = this.parent.getParentDatabase().getParent();
         var2 = var5.FindOrCreateDateTime(var1);
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public void setDateTimeValue(DateTime var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetDate(1063, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public Document getParent() throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.parent;
   }

   public Vector getValues() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var1;
      try {
         var1 = ((NotesBase)this).PropGetVector(1053);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setValues(Vector var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetVector(1053, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getValueString() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1053);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setValueString(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1053, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public double getValueDouble() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      double var1;
      try {
         var1 = ((NotesBase)this).PropGetDouble(1053);
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public void setValueDouble(double var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetDouble(1053, var1);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public int getValueInteger() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1053);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setValueInteger(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetInt(1053, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getType() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1051);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int getValueLength() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1052);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1050);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public String getText() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1059);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getText(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var2;
      try {
         String var5 = ((NotesBase)this).PropGetString(1059);
         if (var5 != null && var1 != 0 && var1 < var5.length()) {
            var2 = var5.substring(0, var1);
            return var2;
         }

         var2 = var5;
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public boolean isSaveToDisk() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1091);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSaveToDisk(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1091, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public DateTime getLastModified() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.parent.getParentDatabase().getParent().FindOrCreateDateTime(((NotesBase)this).PropGetDate(1092));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }
}
