package lotus.notes;

import java.text.Format;
import java.text.MessageFormat;
import java.util.Locale;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

public class JavaString {
   public static PropertyResourceBundle resource;

   public JavaString(String var1) {
      if (resource == null) {
         this.initJavaString(var1);
      }

   }

   public String getString(String var1) {
      return resource.getString(var1);
   }

   public static String getFormattedString(String var0, String var1, String var2) {
      Object[] var3 = new Object[]{var1, var2};
      MessageFormat var4 = new MessageFormat(resource.getString(var0));
      return ((Format)var4).format(var3);
   }

   public static String getFormattedString(String var0, String var1) {
      Object[] var2 = new Object[]{var1};
      MessageFormat var3 = new MessageFormat(resource.getString(var0));
      return ((Format)var3).format(var2);
   }

   void initJavaString(String var1) {
      Object var2 = null;

      try {
         if (System.getProperty("user.region") == null) {
            var4 = new Locale(System.getProperty("user.language"), "");
         } else {
            var4 = new Locale(System.getProperty("user.language"), System.getProperty("user.region"));
         }
      } catch (Exception var3) {
         System.err.println("JVM unable to obtain system locale. Defaulting to English.");
         var4 = new Locale("en", "US");
      }

      resource = (PropertyResourceBundle)ResourceBundle.getBundle(var1, var4);
   }
}
