package lotus.notes;

import java.util.Vector;

public class Log extends NotesBase {
   private transient Session session;
   private static final int EVT_UNKNOWN = 0;
   private static final int EVT_COMM = 1;
   private static final int EVT_SECURITY = 2;
   private static final int EVT_MAIL = 3;
   private static final int EVT_REPLICA = 4;
   private static final int EVT_RESOURCE = 5;
   private static final int EVT_MISC = 6;
   private static final int EVT_SERVER = 7;
   private static final int EVT_ALARM = 8;
   private static final int EVT_UPDATE = 9;
   public static final int SEV_UNKNOWN = 0;
   public static final int SEV_FATAL = 1;
   public static final int SEV_FAILURE = 2;
   public static final int SEV_WARNING1 = 3;
   public static final int SEV_WARNING2 = 4;
   public static final int SEV_NORMAL = 5;
   public static final int EV_UNKNOWN = 0;
   public static final int EV_COMM = 1;
   public static final int EV_SECURITY = 2;
   public static final int EV_MAIL = 3;
   public static final int EV_REPLICA = 4;
   public static final int EV_RESOURCE = 5;
   public static final int EV_MISC = 6;
   public static final int EV_SERVER = 7;
   public static final int EV_ALARM = 8;
   public static final int EV_UPDATE = 9;

   private native void NopenNotesLog(String var1, String var2);

   private native void NopenFileLog(String var1);

   private native void NopenMailLog(Vector var1, String var2);

   private native void NopenAgentLog();

   private native void NlogAction(String var1);

   private native void NlogError(int var1, String var2);

   private native void NlogEvent(String var1, String var2, int var3, int var4);

   private native void Nclose();

   protected Log() throws NotesException {
   }

   protected Log(Session var1, int var2) throws NotesException {
      super(var2, 12);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_session_object"));
      } else {
         this.session = var1;
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.session.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.session.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public void openNotesLog(String var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NopenNotesLog(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void openFileLog(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NopenFileLog(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void openMailLog(Vector var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NopenMailLog(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void openAgentLog() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NopenAgentLog();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void logAction(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NlogAction(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void logError(int var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NlogError(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void logEvent(String var1, String var2, int var3, int var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NlogEvent(var1, var2, var3, var4);
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public void close() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.Nclose();
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public boolean isLogErrors() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1311);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setLogErrors(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1311, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isLogActions() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1312);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setLogActions(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1312, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getNumActions() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1313);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int getNumErrors() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1314);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean isOverwriteFile() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1315);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setOverwriteFile(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1315, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getProgramName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1316);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setProgramName(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1316, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String toString() {
      String var1;
      try {
         var1 = this.getProgramName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }
}
