package lotus.notes;

public class Newsletter extends NotesBase {
   private transient Session session;

   private native int NformatMsgWithDoclinks(Database var1);

   private native int NformatDocument(Database var1, int var2);

   protected Newsletter() throws NotesException {
   }

   protected Newsletter(Session var1, int var2) throws NotesException {
      super(var2, 7);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_session_object"));
      } else {
         this.session = var1;
         var1.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.session.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.session.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public Document formatMsgWithDoclinks(Database var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Document var2;
      try {
         int var5 = this.NformatMsgWithDoclinks(var1);
         if (var1 == null) {
            var1 = DbDirectory.openMailDatabase(this.session);
            var2 = var1.FindOrCreateDocument(var5);
            return var2;
         }

         var2 = var1.FindOrCreateDocument(var5);
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public Document formatDocument(Database var1, int var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_db_object"));
      } else if (var1 != null) {
         synchronized(this){}

         Document var3;
         try {
            var3 = var1.FindOrCreateDocument(this.NformatDocument(var1, var2));
         } catch (Throwable var7) {
            throw var7;
         }

         return var3;
      } else {
         return null;
      }
   }

   public boolean isDoSubject() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1220);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setDoSubject(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1220, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isDoScore() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1221);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setDoScore(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1221, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getSubjectItemName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1222);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setSubjectItemName(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1222, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }
}
