package lotus.notes;

public class Registration extends NotesBase {
   transient Session session;
   public static final int ID_FLAT = 171;
   public static final int ID_HIERARCHICAL = 172;
   public static final int ID_CERTIFIER = 173;

   private native boolean NregisterNewUser(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10, String var11);

   private native boolean NregisterNewServer(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10);

   private native boolean NcrossCertify(String var1, String var2, String var3);

   private native boolean Nrecertify(String var1, String var2, String var3);

   private native boolean NregisterNewCertifier(String var1, String var2, String var3, String var4);

   private native String NswitchToID(String var1, String var2);

   private native boolean NaddUserToAddressBook(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10, String var11);

   private native boolean NaddServerToAddressBook(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9);

   private native boolean NaddCertifierToAddressBook(String var1, String var2, String var3, String var4);

   private native void NgetIDFromServer(String var1, String var2, boolean var3);

   private native void NdeleteIDOnServer(String var1, boolean var2);

   private native void NaddUserProfile(String var1, String var2);

   private native void NgetUserInfo(String var1, String var2, String var3, String var4, String var5, String var6);

   protected Registration(Session var1, int var2) throws NotesException {
      super(var2, 17);
      this.session = var1;
      var1.AddObject(this);
   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public boolean registerNewUser(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var4;
      try {
         var4 = this.registerNewUser(var1, var2, var3, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public boolean registerNewUser(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10, String var11) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var12;
      try {
         var12 = this.NregisterNewUser(var1, var2, var3, var4, var5, var6, var7, var8, var9, var10, var11);
      } catch (Throwable var16) {
         throw var16;
      }

      return var12;
   }

   public boolean registerNewServer(String var1, String var2, String var3, String var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var5;
      try {
         var5 = this.registerNewServer(var1, var2, var3, var4, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null);
      } catch (Throwable var9) {
         throw var9;
      }

      return var5;
   }

   public boolean registerNewServer(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var11;
      try {
         var11 = this.NregisterNewServer(var1, var2, var3, var4, var5, var6, var7, var8, var9, var10);
      } catch (Throwable var15) {
         throw var15;
      }

      return var11;
   }

   public boolean crossCertify(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.crossCertify(var1, (String)null, (String)null);
   }

   public boolean crossCertify(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var4;
      try {
         var4 = this.NcrossCertify(var1, var2, var3);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public boolean recertify(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.recertify(var1, (String)null, (String)null);
   }

   public boolean recertify(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var4;
      try {
         var4 = this.Nrecertify(var1, var2, var3);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public boolean registerNewCertifier(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.registerNewCertifier(var1, var2, var3, (String)null);
   }

   public boolean registerNewCertifier(String var1, String var2, String var3, String var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var5;
      try {
         var5 = this.NregisterNewCertifier(var1, var2, var3, var4);
      } catch (Throwable var9) {
         throw var9;
      }

      return var5;
   }

   public String switchToID(String var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var3;
      try {
         var3 = this.NswitchToID(var1, var2);
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public boolean addUserToAddressBook(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var4;
      try {
         var4 = this.addUserToAddressBook(var1, var2, var3, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null);
      } catch (Throwable var8) {
         throw var8;
      }

      return var4;
   }

   public boolean addUserToAddressBook(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10, String var11) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var12;
      try {
         var12 = this.NaddUserToAddressBook(var1, var2, var3, var4, var5, var6, var7, var8, var9, var10, var11);
      } catch (Throwable var16) {
         throw var16;
      }

      return var12;
   }

   public boolean addServerToAddressBook(String var1, String var2, String var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.addServerToAddressBook(var1, var2, var3, (String)null, (String)null, (String)null, (String)null, (String)null, (String)null);
   }

   public boolean addServerToAddressBook(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var10;
      try {
         var10 = this.NaddServerToAddressBook(var1, var2, var3, var4, var5, var6, var7, var8, var9);
      } catch (Throwable var14) {
         throw var14;
      }

      return var10;
   }

   public boolean addCertifierToAddressBook(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.addCertifierToAddressBook(var1, (String)null, (String)null, (String)null);
   }

   public boolean addCertifierToAddressBook(String var1, String var2, String var3, String var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var5;
      try {
         var5 = this.NaddCertifierToAddressBook(var1, var2, var3, var4);
      } catch (Throwable var9) {
         throw var9;
      }

      return var5;
   }

   public void getIDFromServer(String var1, String var2, boolean var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NgetIDFromServer(var1, var2, var3);
      } catch (Throwable var6) {
         throw var6;
      }

   }

   public void deleteIDOnServer(String var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NdeleteIDOnServer(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void addUserProfile(String var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NaddUserProfile(var1, var2);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void getUserInfo(String var1, String var2, String var3, String var4, String var5, String var6) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NgetUserInfo(var1, var2, var3, var4, var5, var6);
      } catch (Throwable var9) {
         throw var9;
      }

   }

   public String getRegistrationLog() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1470);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setRegistrationLog(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1470, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public DateTime getExpiration() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var1;
      try {
         var1 = this.session.FindOrCreateDateTime(((NotesBase)this).PropGetDate(1471));
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setExpiration(DateTime var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetDate(1471, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getMinPasswordLength() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1472);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setMinPasswordLength(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetInt(1472, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean isNorthAmerican() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1473);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setNorthAmerican(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1473, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getCertifierIDFile() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1474);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setCertifierIDFile(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1474, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getRegistrationServer() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1475);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setRegistrationServer(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1475, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public String getOrgUnit() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1476);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setOrgUnit(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetString(1476, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public int getIDType() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      int var1;
      try {
         var1 = ((NotesBase)this).PropGetInt(1477);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setIDType(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetInt(1477, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean getCreateMailDb() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1478);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setCreateMailDb(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1478, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean getUpdateAddressBook() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1479);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setUpdateAddressBook(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1479, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public boolean getStoreIDInAddressBook() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1480);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void setStoreIDInAddressBook(boolean var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         ((NotesBase)this).PropSetBool(1480, var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }
}
