package lotus.notes;

public class RichTextStyle extends NotesBase {
   private transient Session session;
   public static final int EFFECTS_NONE = 0;
   public static final int EFFECTS_SUPERSCRIPT = 1;
   public static final int EFFECTS_SUBSCRIPT = 2;
   public static final int EFFECTS_SHADOW = 3;
   public static final int EFFECTS_EMBOSS = 4;
   public static final int EFFECTS_EXTRUDE = 5;
   public static final int COLOR_BLACK = 0;
   public static final int COLOR_WHITE = 1;
   public static final int COLOR_RED = 2;
   public static final int COLOR_GREEN = 3;
   public static final int COLOR_BLUE = 4;
   public static final int COLOR_MAGENTA = 5;
   public static final int COLOR_YELLOW = 6;
   public static final int COLOR_CYAN = 7;
   public static final int COLOR_DARK_RED = 8;
   public static final int COLOR_DARK_GREEN = 9;
   public static final int COLOR_DARK_BLUE = 10;
   public static final int COLOR_DARK_MAGENTA = 11;
   public static final int COLOR_DARK_YELLOW = 12;
   public static final int COLOR_DARK_CYAN = 13;
   public static final int COLOR_GRAY = 14;
   public static final int COLOR_LIGHT_GRAY = 15;
   public static final int FONT_ROMAN = 0;
   public static final int FONT_HELV = 1;
   public static final int FONT_COURIER = 4;
   public static final int STYLE_NO_CHANGE = 255;
   public static final int YES = 1;
   // $FF: renamed from: NO int
   public static final int field_0 = 0;
   public static final int MAYBE = 255;

   protected RichTextStyle() throws NotesException {
   }

   protected RichTextStyle(Session var1, int var2) throws NotesException {
      super(var2, 24);
      if (var1 == null) {
         throw new NotesException(JavaString.resource.getString("missing_session_object"));
      } else {
         this.session = var1;
         this.session.AddObject(this);
      }
   }

   protected void InternalFinalize() throws NotesException {
      super.finalize();
   }

   public void finalize() throws NotesException {
      this.session.RemoveObject(this);
      this.InternalFinalize();
   }

   public void recycle() throws NotesException {
      try {
         this.session.RemoveObject(this);
      } catch (NotesException var5) {
      } finally {
         super.Recycle();
      }

   }

   public int GetCppObj() {
      return super.GetCppObj();
   }

   public void remove() throws NotesException {
      ((NotesBase)this).CheckObject();
      this.session.RemoveObject(this);
      super.cpp_object = 0;
      this.finalize();
   }

   public int getBold() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1805);
   }

   public void setBold(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1805, var1);
   }

   public int getItalic() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1806);
   }

   public void setItalic(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1806, var1);
   }

   public int getUnderline() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1807);
   }

   public void setUnderline(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1807, var1);
   }

   public int getStrikeThrough() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1808);
   }

   public void setStrikeThrough(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1808, var1);
   }

   public int getEffects() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1810);
   }

   public void setEffects(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1810, var1);
   }

   public int getFont() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1809);
   }

   public void setFont(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1809, var1);
   }

   public int getFontSize() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1811);
   }

   public void setFontSize(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1811, var1);
   }

   public int getColor() throws NotesException {
      ((NotesBase)this).CheckObject();
      return ((NotesBase)this).PropGetInt(1812);
   }

   public void setColor(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      ((NotesBase)this).PropSetInt(1812, var1);
   }
}
