package lotus.notes;

import java.util.Enumeration;
import java.util.Vector;

public class Session extends NotesBase {
   private transient Vector dblist = new Vector(3, 3);
   private transient Vector objlist = new Vector(3, 3);
   private transient AgentContext agentcontext;
   protected transient int context_cookie;
   private static transient int counter;
   protected static Vector sessions;

   private static native int NCreateSession(int var0);

   private native Vector NEvaluate(String var1, Document var2);

   private native String NgetEnvironmentString(String var1, boolean var2);

   private native Object NgetEnvironmentValue(String var1, boolean var2);

   private native void NsetEnvironmentVar(String var1, Object var2, boolean var3);

   private native int[] NfreeTimeSearch(DateRange var1, int var2, Object var3, boolean var4);

   private native int NgetDbDirectory(String var1);

   private native int NgetDatabase(String var1, String var2);

   private native int NcreateDateTime(String var1);

   private native int NcreateLog(String var1);

   private native int NcreateNewsletter(DocumentCollection var1);

   private native int NcreateDateRange();

   private native int NcreateName(String var1);

   private native int NgetURLDatabase();

   private native void NendAgentContext();

   private native int NcreateRegistration();

   private native int NcreateRTStyle();

   public static Session newInstance() throws NotesException {
      try {
         int var0 = NCreateSession(0);
         return FindOrCreateSession(var0, 0);
      } catch (Exception var1) {
         if (var1 instanceof NotesException) {
            throw (NotesException)var1;
         } else {
            ((Throwable)var1).printStackTrace();
            return null;
         }
      }
   }

   public static Session newInstance(int var0) throws NotesException {
      try {
         int var1 = NCreateSession(var0);
         return FindOrCreateSession(var1, var0);
      } catch (Exception var2) {
         if (var2 instanceof NotesException) {
            throw (NotesException)var2;
         } else {
            ((Throwable)var2).printStackTrace();
            return null;
         }
      }
   }

   protected static synchronized Session FindOrCreateSession(int var0, int var1) throws NotesException {
      if (sessions == null) {
         sessions = new Vector(3, 3);
      }

      Vector var4 = sessions;
      synchronized(var4){}

      Session var3;
      try {
         Enumeration var6 = sessions.elements();

         Session var2;
         do {
            if (!var6.hasMoreElements()) {
               return new Session(var0, var1);
            }

            var2 = (Session)var6.nextElement();
         } while(!((NotesBase)var2).isEqual(var0) || var2.context_cookie != var1);

         ((NotesBase)var2).CheckObject();
         var3 = var2;
      } catch (Throwable var8) {
         throw var8;
      }

      return var3;
   }

   public synchronized void endAgentContext() {
      if (super.cpp_object > 0) {
         try {
            this.NendAgentContext();
            this.finalize();
         } catch (Exception var2) {
            ((Throwable)var2).printStackTrace();
         }
      }
   }

   protected Session(int var1) throws NotesException {
      super(var1, 1);
      this.context_cookie = 0;
      Vector var2 = sessions;
      synchronized(var2){}

      try {
         sessions.addElement(this);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected Session(int var1, int var2) throws NotesException {
      super(var1, 1);
      this.context_cookie = var2;
      Vector var3 = sessions;
      synchronized(var3){}

      try {
         sessions.addElement(this);
      } catch (Throwable var5) {
         throw var5;
      }

   }

   public void finalize() throws NotesException {
      try {
         Vector var5 = this.dblist;
         synchronized(var5){}

         try {
            Enumeration var2 = this.dblist.elements();

            while(var2.hasMoreElements()) {
               Database var1 = (Database)var2.nextElement();
               ((NotesBase)this).DestroyObject(var1);
               var1.InternalFinalize();
            }
         } catch (Throwable var87) {
            throw var87;
         }

         var5 = this.objlist;
         synchronized(var5){}

         try {
            Enumeration var89 = this.objlist.elements();

            while(var89.hasMoreElements()) {
               NotesBase var7 = (NotesBase)var89.nextElement();
               ((NotesBase)this).DestroyObject(var7);
               var7.InternalFinalize();
            }
         } catch (Throwable var86) {
            throw var86;
         }
      } finally {
         if (this.dblist != null) {
            Vector var91 = this.dblist;
            synchronized(var91){}

            try {
               this.dblist.removeAllElements();
               this.dblist = null;
            } catch (Throwable var85) {
               throw var85;
            }
         }

         if (this.objlist != null) {
            Vector var92 = this.objlist;
            synchronized(var92){}

            try {
               this.objlist.removeAllElements();
               this.objlist = null;
            } catch (Throwable var84) {
               throw var84;
            }
         }

         Vector var93 = sessions;
         synchronized(var93){}

         try {
            sessions.removeElement(this);
         } catch (Throwable var83) {
            throw var83;
         }

         super.cpp_object = 0;
         this.context_cookie = 0;
         super.finalize();
      }

   }

   protected void AddDatabase(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var2 = this.dblist;
      synchronized(var2){}

      try {
         this.dblist.addElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected void RemoveDatabase(Object var1) throws NotesException {
      if (this.dblist != null) {
         Vector var2 = this.dblist;
         synchronized(var2){}

         try {
            this.dblist.removeElement(var1);
         } catch (Throwable var4) {
            throw var4;
         }

      }
   }

   protected void AddObject(Object var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var2 = this.objlist;
      synchronized(var2){}

      try {
         this.objlist.addElement(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   protected void RemoveObject(Object var1) throws NotesException {
      if (this.objlist != null) {
         Vector var2 = this.objlist;
         synchronized(var2){}

         try {
            this.objlist.removeElement(var1);
         } catch (Throwable var4) {
            throw var4;
         }

      }
   }

   protected DbDirectory FindOrCreateDbDirectory(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         DbDirectory var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new DbDirectory(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof DbDirectory) || !var2.isEqual(var1));

            var3 = (DbDirectory)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected Database FindOrCreateDatabase(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.dblist;
         synchronized(var4){}

         Database var3;
         try {
            Enumeration var6 = this.dblist.elements();

            Database var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new Database(this, var1);
               }

               var2 = (Database)var6.nextElement();
            } while(!((NotesBase)var2).isEqual(var1));

            var3 = var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected DateTime FindOrCreateDateTime(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         DateTime var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new DateTime(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof DateTime) || !var2.isEqual(var1));

            var3 = (DateTime)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected DateRange FindOrCreateDateRange(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         DateRange var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new DateRange(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof DateRange) || !var2.isEqual(var1));

            var3 = (DateRange)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected Log FindOrCreateLog(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         Log var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new Log(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof Log) || !var2.isEqual(var1));

            var3 = (Log)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected Newsletter FindOrCreateNewsletter(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         Newsletter var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new Newsletter(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof Newsletter) || !var2.isEqual(var1));

            var3 = (Newsletter)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected Name FindOrCreateName(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         Name var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new Name(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof Name) || !var2.isEqual(var1));

            var3 = (Name)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected RichTextStyle FindOrCreateRTStyle(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         RichTextStyle var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new RichTextStyle(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof RichTextStyle) || !var2.isEqual(var1));

            var3 = (RichTextStyle)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected Registration FindOrCreateRegistration(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      if (var1 == 0) {
         return null;
      } else {
         Vector var4 = this.objlist;
         synchronized(var4){}

         Registration var3;
         try {
            Enumeration var6 = this.objlist.elements();

            NotesBase var2;
            do {
               if (!var6.hasMoreElements()) {
                  return new Registration(this, var1);
               }

               var2 = (NotesBase)var6.nextElement();
            } while(!(var2 instanceof Registration) || !var2.isEqual(var1));

            var3 = (Registration)var2;
         } catch (Throwable var8) {
            throw var8;
         }

         return var3;
      }
   }

   protected NotesBase FindObject(int var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      Vector var4 = this.objlist;
      synchronized(var4){}

      NotesBase var3;
      try {
         Enumeration var6 = this.objlist.elements();

         NotesBase var2;
         do {
            if (!var6.hasMoreElements()) {
               return null;
            }

            var2 = (NotesBase)var6.nextElement();
         } while(!var2.isEqual(var1));

         var3 = var2;
      } catch (Throwable var8) {
         throw var8;
      }

      return var3;
   }

   public Vector evaluate(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.evaluate(var1, (Document)null);
   }

   public Vector evaluate(String var1, Document var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var3;
      try {
         var3 = this.NEvaluate(var1, var2);
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Database getDatabase(String var1, String var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var3;
      try {
         var3 = this.FindOrCreateDatabase(this.NgetDatabase(var1, var2));
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public DateTime createDateTime(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateTime var2;
      try {
         var2 = this.FindOrCreateDateTime(this.NcreateDateTime(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Log createLog(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Log var2;
      try {
         var2 = this.FindOrCreateLog(this.NcreateLog(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public Newsletter createNewsletter(DocumentCollection var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Newsletter var2;
      try {
         var2 = this.FindOrCreateNewsletter(this.NcreateNewsletter(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public DbDirectory getDbDirectory(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DbDirectory var2;
      try {
         var2 = this.FindOrCreateDbDirectory(this.NgetDbDirectory(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public DateRange createDateRange() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      DateRange var1;
      try {
         var1 = this.FindOrCreateDateRange(this.NcreateDateRange());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public DateRange createDateRange(DateTime var1, DateTime var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      DateRange var3 = this.createDateRange();
      var3.setStartDateTime(var1);
      var3.setEndDateTime(var2);
      return var3;
   }

   public Name createName(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Name var2;
      try {
         var2 = this.FindOrCreateName(this.NcreateName(var1));
      } catch (Throwable var6) {
         throw var6;
      }

      return var2;
   }

   public RichTextStyle createRichTextStyle() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      RichTextStyle var1;
      try {
         var1 = this.FindOrCreateRTStyle(this.NcreateRTStyle());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getEnvironmentString(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.getEnvironmentString(var1, false);
   }

   public String getEnvironmentString(String var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var3;
      try {
         var3 = this.NgetEnvironmentString(var1, var2);
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public Object getEnvironmentValue(String var1) throws NotesException {
      ((NotesBase)this).CheckObject();
      return this.getEnvironmentValue(var1, false);
   }

   public Object getEnvironmentValue(String var1, boolean var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Object var3;
      try {
         var3 = this.NgetEnvironmentValue(var1, var2);
      } catch (Throwable var7) {
         throw var7;
      }

      return var3;
   }

   public void setEnvironmentVar(String var1, Object var2) throws NotesException {
      ((NotesBase)this).CheckObject();
      this.setEnvironmentVar(var1, var2, false);
   }

   public void setEnvironmentVar(String var1, Object var2, boolean var3) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      try {
         this.NsetEnvironmentVar(var1, var2, var3);
      } catch (Throwable var6) {
         throw var6;
      }

   }

   public Vector freeTimeSearch(DateRange var1, int var2, Object var3, boolean var4) throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var5;
      try {
         int[] var8 = this.NfreeTimeSearch(var1, var2, var3, var4);
         Vector var9 = null;
         if (var8 != null && var8.length > 0) {
            var9 = new Vector(var8.length, 1);

            for(int var10 = 0; var10 < var8.length; ++var10) {
               DateRange var11 = this.FindOrCreateDateRange(var8[var10]);
               var9.addElement(var11);
            }
         }

         var5 = var9;
      } catch (Throwable var13) {
         throw var13;
      }

      return var5;
   }

   public Database getURLDatabase() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Database var1;
      try {
         Database var4 = this.FindOrCreateDatabase(this.NgetURLDatabase());
         var1 = var4;
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public Registration createRegistration() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Registration var1;
      try {
         Registration var4 = this.FindOrCreateRegistration(this.NcreateRegistration());
         var1 = var4;
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public Vector getAddressBooks() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      Vector var1;
      try {
         int[] var4 = ((NotesBase)this).PropGetObjArray(1198);
         if (var4.length != 0) {
            Vector var6 = new Vector(var4.length);

            for(int var7 = 0; var7 < var4.length; ++var7) {
               Database var5 = this.FindOrCreateDatabase(var4[var7]);
               var6.addElement(var5);
            }

            var1 = var6;
            return var1;
         }

         var1 = null;
      } catch (Throwable var9) {
         throw var9;
      }

      return var1;
   }

   public String getCommonUserName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1201);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public International getInternational() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      International var2;
      try {
         int var5 = ((NotesBase)this).PropGetAdt(1213);
         International var1 = (International)this.FindObject(var5);
         if (var1 == null) {
            var1 = new International(this, var5);
         }

         var2 = var1;
      } catch (Throwable var7) {
         throw var7;
      }

      return var2;
   }

   public boolean isOnServer() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      boolean var1;
      try {
         var1 = ((NotesBase)this).PropGetBool(1196);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getNotesVersion() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1200);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getPlatform() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1191);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String getUserName() throws NotesException {
      ((NotesBase)this).CheckObject();
      synchronized(this){}

      String var1;
      try {
         var1 = ((NotesBase)this).PropGetString(1190);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public String toString() {
      String var1;
      try {
         var1 = this.getUserName();
      } catch (Exception var2) {
         var1 = null;
      }

      return var1;
   }

   public Name getUserNameObject() throws NotesException {
      ((NotesBase)this).CheckObject();
      String var2 = this.getUserName();
      if (var2 != null) {
         Name var1 = this.createName(var2);
         return var1;
      } else {
         return null;
      }
   }

   public AgentContext getAgentContext() throws NotesException {
      ((NotesBase)this).CheckObject();
      if (this.agentcontext == null) {
         synchronized(this){}

         try {
            int var3 = ((NotesBase)this).PropGetAdt(1901);
            if (var3 != 0) {
               this.agentcontext = new AgentContext(this, var3);
            }
         } catch (Throwable var5) {
            throw var5;
         }
      }

      return this.agentcontext;
   }
}
