package lotus.notes.addins;

import java.util.Vector;
import lotus.domino.NotesThread;
import lotus.notes.JavaString;
import lotus.notes.NotesException;

public abstract class JavaServerAddin extends NotesThread {
   public static final int NOERROR = 0;
   public static final short ST_UNIQUE = 0;
   public static final short ST_ADDITIVE = 1;
   public static final short VT_LONG = 0;
   public static final short VT_TEXT = 1;
   public static final short VT_TIMEDATE = 2;
   public static final short VT_NUMBER = 3;
   public static final String MSG_Q_PREFIX = "MQ$";
   private boolean addInQuit = false;

   protected native void AddInLogMessageText(String var1, int var2);

   protected native void AddInLogErrorText(String var1, int var2);

   protected native boolean AddInIdle();

   protected native boolean AddInShouldTerminate();

   protected native void OSPreemptOccasionally();

   protected native boolean AddInDayHasElapsed();

   protected native void AddInSetStatusText(String var1);

   protected native void AddInSetStatusLine(int var1, String var2);

   protected native boolean AddInMinutesHaveElapsed(int var1);

   protected native boolean AddInSecondsHaveElapsed(int var1);

   protected native int AddInCreateStatusLine(String var1);

   protected native void AddInSetDefaults(int var1, int var2);

   protected native void AddInDeleteStatusLine(int var1);

   protected native Vector AddInQueryDefaults();

   protected native int StatUpdate(String var1, String var2, short var3, short var4, Object var5);

   protected native void StatDelete(String var1, String var2);

   protected native String OSLoadString(int var1);

   public JavaServerAddin() {
      try {
         String var1 = System.getProperty("os.name");
         String var2 = System.getProperty("os.arch");
         String var4 = null;
         String var5 = "";
         var1 = var1.toUpperCase();
         var2 = var2.toUpperCase();
         if (!var1.equals("WINDOWS NT") && !var1.equals("WINDOWS 95")) {
            if (var1.equals("WINDOWS")) {
               var4 = "_";
            } else if (var1.equals("OS/2")) {
               var4 = "i";
            } else if (var1.equals("AIX")) {
               var4 = "";
               var5 = "_r";
            } else if (var1.equals("SOLARIS")) {
               var4 = "";
            } else if (var1.equals("HPUX")) {
               var4 = "";
            } else if (var1.equals("OS/400")) {
               var4 = "lib";
            } else {
               var4 = "";
            }
         } else if (var2.equals("X86")) {
            var4 = "n";
         } else if (var2.equals("ALPHA")) {
            var4 = "a";
         }

         if (var4 == null) {
            JavaString var6 = new JavaString("lotus.notes.AgentResources");
            throw new NotesException(var6.getString("system_dll") + " " + var1);
         } else {
            String var3 = var4 + "wmsgtrc" + var5;
            System.loadLibrary(var3);
         }
      } catch (Exception var7) {
         ((Throwable)var7).printStackTrace();
      }
   }

   public void stopAddin() {
      this.addInQuit = true;
   }

   public boolean shouldTerminate() {
      return this.AddInShouldTerminate() || this.addInQuit;
   }

   public abstract void runNotes();

   protected boolean addInRunning() {
      return !this.AddInIdle() && !this.addInQuit;
   }
}
