package lotus.notes.addins.ispy;

import lotus.domino.Document;
import lotus.domino.NotesException;
import lotus.notes.addins.InternationalResources;

public final class MailProbeDoc {
   public static final String MAIL_PROBE_VIEW = "va_MailProbes";
   public static final String FORM_NAME = "fa_MailProbe";
   public static final String MAIL_PROBE_NAME = "MailProbeName";
   public static final String MAIL_TIMEOUT = "MailTimeOut";
   public static final String TARGET_RECIPIENT = "TargetRecipient";
   public static final String MAIL_PROBE_STATISTIC_NAME = "MailProbeStatisticName";
   public static final String MAIL_PROBE_INTERVAL = "MailProbeInterval";
   public static final String DISABLED_FLAG = "Disabled";
   public static final String EVENT_SEVERITY = "Severity";
   public static final String SOURCE_SERVER = "SourceServerName";
   public static final String ALL_SELF_MONITOR = "AllSelfMonitor";
   private String probe_name;
   private int timeout;
   private String recipient;
   private String stat_name;
   private int severity;

   public MailProbeDoc(Document var1, String var2, InternationalResources var3) throws NotesException {
      this.probe_name = var1.getItemValueString("MailProbeName");
      this.timeout = var1.getItemValueInteger("MailTimeOut");
      this.stat_name = var1.getItemValueString("MailProbeStatisticName");
      Integer var4 = new Integer(var1.getItemValueString("Severity"));
      this.severity = var4;
      if (var1.getItemValueString("AllSelfMonitor") == null) {
         this.recipient = var1.getItemValueString("TargetRecipient");
         this.stat_name = var1.getItemValueString("MailProbeStatisticName");
      } else {
         this.recipient = var2;
         this.stat_name = new String();
         this.stat_name = var3.getString("stat_mail_str") + "." + var2 + "." + var3.getString("stat_response_time_str");
      }
   }

   public String getMailProbeName() {
      return this.probe_name;
   }

   public int getMailTimeout() {
      return this.timeout;
   }

   public String getTargetRecipient() {
      return this.recipient;
   }

   public String getStatisticName() {
      return this.stat_name;
   }

   public int getSeverity() {
      return this.severity;
   }
}
