package lotus.notes.addins.ispy;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Date;
import java.util.Enumeration;
import java.util.EventObject;
import java.util.Vector;
import lotus.domino.Database;
import lotus.domino.DateTime;
import lotus.domino.Document;
import lotus.domino.DocumentCollection;
import lotus.domino.Log;
import lotus.domino.Name;
import lotus.domino.NotesException;
import lotus.domino.NotesFactory;
import lotus.domino.Session;
import lotus.domino.View;
import lotus.notes.addins.InternationalResources;
import lotus.notes.addins.JavaServerAddin;
import lotus.notes.addins.ispy.net.portcheck.HTTPCheck;
import lotus.notes.addins.ispy.net.portcheck.HostCheck;
import lotus.notes.addins.ispy.net.portcheck.HostCheckEvent;
import lotus.notes.addins.ispy.net.portcheck.HostCheckListener;
import lotus.notes.addins.ispy.net.portcheck.IMAP4Check;
import lotus.notes.addins.ispy.net.portcheck.LDAPCheck;
import lotus.notes.addins.ispy.net.portcheck.NNTPCheck;
import lotus.notes.addins.ispy.net.portcheck.POP3Check;
import lotus.notes.addins.ispy.net.portcheck.PortCheck;
import lotus.notes.addins.ispy.net.portcheck.PortCheckEvent;
import lotus.notes.addins.ispy.net.portcheck.SMTPCheck;
import lotus.notes.addins.ispy.util.ActiveList;
import lotus.notes.addins.ispy.util.Appointment;
import lotus.notes.addins.ispy.util.Schedule;

public class TCPPoller extends JavaServerAddin implements HostCheckListener {
   private static Session notes_session;
   private InternationalResources international_string;
   private View servers_view;
   private String STAT_EVENTS_DB_NAME;
   private final int ONE_MINUTE = 60000;
   private final int DEFAULT_TIMEOUT = 10000;
   private Database stat_events_db;
   private String addin_name;
   protected boolean able_to_perform_ip_probing = false;
   private String this_server;
   private String this_server_abbreviated_name;
   private String this_domain;
   private TCPProbeDoc current_doc;
   private HostCheckEvent host_probe_result;
   private InetAddress http_proxy_host;
   private int http_proxy_port = 8080;
   private Vector no_proxy_list;
   private boolean currently_probing = false;
   private boolean initialized = false;
   public int debug;
   private Log event_handle;
   private Schedule probe_schedule = new Schedule();
   private ActiveList stat_list = new ActiveList();
   private TCPServerTasks tcp_server_tasks;
   private DateTime last_schedule_update_time;
   private int DEFAULT_POLL_TIME = 60000;
   private static String EVENT_QUEUE_NAME;
   private boolean sent_event_error_messsage = false;

   public TCPPoller(InternationalResources var1) {
      this.international_string = var1;
      this.STAT_EVENTS_DB_NAME = var1.getString("statistics_database_name");
      this.addin_name = var1.getString("addin_name");
      EVENT_QUEUE_NAME = var1.getString("event_queue_name");
   }

   public boolean currentlyProbing() {
      return this.currently_probing;
   }

   public boolean initialized() {
      return this.initialized;
   }

   public void runNotes() {
      Date var1 = null;

      try {
         if (!this.getConfigurationData()) {
            return;
         }
      } catch (NotesException var40) {
         return;
      }

      this.initialized = true;

      try {
         while(((JavaServerAddin)this).addInRunning()) {
            try {
               this.getDatabasesAndViews();
               if (this.able_to_perform_ip_probing) {
                  this.initSchedule();
                  var1 = this.probe_schedule.getTimeOfNextAppointment();
                  if (var1 != null && this.probe_schedule.size() > 0) {
                     if (var1.getTime() < System.currentTimeMillis()) {
                        this.currently_probing = true;
                        if (this.debug > 0) {
                           Date var7 = new Date();
                           System.out.println(var7 + " ISpy: Starting IP probes...");
                        }
                     }

                     Object var45;
                     for(; var1.getTime() < System.currentTimeMillis() && !((JavaServerAddin)this).shouldTerminate(); var45 = null) {
                        Appointment var42 = (Appointment)this.probe_schedule.firstElement();
                        var42.repeat();
                        this.probe_schedule.removeElementAt(0);
                        this.probe_schedule.addAppointment(var42);
                        var1 = this.probe_schedule.getTimeOfNextAppointment();
                        var45 = null;
                        ((JavaServerAddin)this).OSPreemptOccasionally();
                        var45 = null;
                        Vector var9 = (Vector)var42.getData();
                        HostCheck var10 = (HostCheck)var9.elementAt(0);
                        this.current_doc = (TCPProbeDoc)var9.elementAt(1);
                        String var11 = this.current_doc.getTargetServer();
                        Document var12 = NABUtils.getFirstDocumentFromAddressBook(notes_session, 0, var11);
                        int var6 = this.current_doc.getTimeout() * 1000;
                        InetAddress var44 = this.getIPAddress(var12, var11);
                        if (var12 != null) {
                           Database var13 = var12.getParentDatabase();
                           var12.recycle();
                           Object var46 = null;
                           var13.recycle();
                           Object var47 = null;
                        }

                        if (var44 != null) {
                           var10.start(this, var6, var44, var6 / 2);
                           ((Thread)this).suspend();
                           var10.stop();
                           this.checkResult();
                        } else {
                           Vector var48 = var10.getChecks();
                           int var14 = var48.size();

                           for(int var15 = 0; var15 < var14; ++var15) {
                              PortCheck var16 = (PortCheck)var48.elementAt(var15);
                              ((JavaServerAddin)this).StatUpdate(this.international_string.getString("facility_id"), this.current_doc.getStatisticName(var16.getServiceAbbreviation()), (short)0, (short)0, new Long(-1L));

                              try {
                                 this.event_handle.logEvent(this.international_string.getString("error_server_no_ip_address") + " = " + var11 + " : " + this.international_string.getString("facility_id") + "." + this.current_doc.getStatisticName(var16.getServiceAbbreviation()), EVENT_QUEUE_NAME, TCPProbeDoc.getEventType(var16.getServiceAbbreviation()), this.current_doc.getSeverity());
                                 this.sent_event_error_messsage = false;
                              } catch (NotesException var33) {
                                 if (!this.sent_event_error_messsage) {
                                    ((JavaServerAddin)this).AddInLogMessageText(this.addin_name + ": " + this.international_string.getString("logevent_failure"), 0);
                                 }

                                 this.sent_event_error_messsage = true;
                              }
                           }

                           ((JavaServerAddin)this).AddInLogMessageText(this.addin_name + ": " + this.international_string.getString("error_server_no_ip_address") + "= " + var11, 0);
                        }
                     }
                  }
               }
            } catch (ISpyFatalException var34) {
               super.stopAddin();
               throw var34;
            } catch (Exception var35) {
               ((Throwable)var35).printStackTrace();
            } finally {
               if (this.currently_probing) {
                  if (this.debug > 0) {
                     Date var41 = new Date();
                     System.out.println(var41 + " ISpy: ...IP probes complete.");
                  }

                  this.currently_probing = false;
               }

               this.current_doc = null;
               this.sleep(var1);
            }
         }
      } catch (ISpyFatalException var37) {
         String var5 = ((Throwable)var37).getMessage();
         if (var5 != null && var5.compareTo("") != 0) {
            ((JavaServerAddin)this).AddInLogErrorText(this.addin_name + ": " + var5, 0);
         }

         ((JavaServerAddin)this).AddInLogErrorText(this.addin_name + ": " + this.international_string.getString("tcp_poller_fatal"), 0);
      } catch (InterruptedException var38) {
      } finally {
         Vector var4 = this.stat_list.getList();
         this.deleteStats(var4);
      }

   }

   private void initSchedule() throws NotesException {
      Object var1 = null;
      Date var2 = new Date();
      DateTime var3 = notes_session.createDateTime("Today");
      var3.setNow();
      this.stat_list.reset();
      this.probe_schedule.reset();
      Vector var4 = this.getServersInDomain();
      Object var5 = null;

      for(Document var6 = this.servers_view.getFirstDocument(); var6 != null; var6 = var15) {
         try {
            if (var6.getItemValueString("Disabled") == null) {
               boolean var9 = false;
               Vector var14 = var6.getItemValue("SourceServerName");
               Enumeration var10 = var14.elements();

               while(var10.hasMoreElements()) {
                  String var11 = (String)var10.nextElement();
                  if (var11.compareTo(this.this_server) == 0 || var11.compareTo("*") == 0) {
                     var9 = true;
                     break;
                  }
               }

               if (var9) {
                  if (this.last_schedule_update_time == null) {
                     this.createAppointments(var6, var4, var2);
                  } else if (this.last_schedule_update_time.timeDifference(var6.getLastModified()) < 0) {
                     this.createAppointments(var6, var4, var2);
                  } else {
                     this.activateAppointments(var6, var4, var2);
                  }
               }
            }
         } finally {
            var15 = this.servers_view.getNextDocument(var6);
            var6.recycle();
         }
      }

      this.probe_schedule.removeInActive();
      if (this.debug > 1) {
         System.out.println("\nISpy: DUMPING TCP PROBE APPOINTMENTS");
      }

      this.probe_schedule.dump(this.debug);
      Vector var7 = this.stat_list.removeInActive();
      this.deleteStats(var7);
      if (this.debug > 1) {
         System.out.println("\nISpy: DUMPING TCP POLLER STAT LIST");
      }

      this.stat_list.dump(this.debug);
      if (this.last_schedule_update_time != null) {
         this.last_schedule_update_time.recycle();
      }

      this.last_schedule_update_time = var3;
   }

   private Vector getServersInDomain() throws NotesException {
      Object var1 = null;
      new Vector();
      Vector var2 = new Vector();
      String var3 = new String("SELECT Form=\"Server\" & Domain=\"") + this.this_domain + "\"";
      Vector var20 = notes_session.getAddressBooks();
      Enumeration var4 = var20.elements();

      while(var4.hasMoreElements()) {
         Database var5 = null;
         Object var6 = null;

         try {
            var5 = (Database)var4.nextElement();
            if (this.openDB(var5)) {
               DocumentCollection var21 = var5.search(var3);
               Object var9 = null;

               for(Document var10 = var21.getFirstDocument(); var10 != null; var10 = var22) {
                  try {
                     String var13 = var10.getItemValueString("ServerName");
                     var2.addElement(var13);
                  } finally {
                     var22 = var21.getNextDocument(var10);
                     var10.recycle();
                  }
               }
            }
         } finally {
            if (var5 != null) {
               var5.recycle();
            }

         }
      }

      return var2;
   }

   private void createAppointments(Document var1, Vector var2, Date var3) throws NotesException {
      Vector var4 = this.determineTargets(var1, var2);
      if (var4 != null) {
         for(int var5 = 0; var5 < var4.size(); ++var5) {
            String var6 = (String)var4.elementAt(var5);
            TCPProbeDoc var7 = new TCPProbeDoc(var1, var6, this.international_string);
            String var8 = var7.getDescription();
            this.probe_schedule.getAppointmentWithDescription(var8, true);
            Appointment var9 = this.createTCPProbeAppointment(var7, var3);
            if (var9 != null) {
               this.probe_schedule.addAppointment(var9);
               this.updateStatList(var9);
            }
         }
      }

   }

   private void activateAppointments(Document var1, Vector var2, Date var3) throws NotesException {
      Object var4 = null;
      Vector var5 = this.determineTargets(var1, var2);
      if (var5 != null) {
         for(int var6 = 0; var6 < var5.size(); ++var6) {
            String var7 = (String)var5.elementAt(var6);
            String var8 = TCPProbeDoc.getDescription(var7, var1);
            Appointment var12 = this.probe_schedule.getAppointmentWithDescription(var8, false);
            if (var12 != null) {
               Vector var9 = (Vector)var12.getData();
               if (var9.size() > 2) {
                  DateTime var10 = (DateTime)var9.elementAt(2);
                  if (this.last_schedule_update_time != null && this.last_schedule_update_time.timeDifference(var10) < 0) {
                     TCPProbeDoc var11 = new TCPProbeDoc(var1, var7, this.international_string);
                     var12 = this.createTCPProbeAppointment(var11, var3);
                     if (var12 != null) {
                        this.probe_schedule.addAppointment(var12);
                        this.updateStatList(var12);
                     }
                  } else {
                     var12.activate();
                     this.updateStatList(var12);
                  }
               } else {
                  var12.activate();
                  this.updateStatList(var12);
               }
            } else {
               TCPProbeDoc var15 = new TCPProbeDoc(var1, var7, this.international_string);
               var12 = this.createTCPProbeAppointment(var15, var3);
               if (var12 != null) {
                  this.probe_schedule.addAppointment(var12);
                  this.updateStatList(var12);
               }
            }
         }
      }

   }

   private Vector determineTargets(Document var1, Vector var2) throws NotesException {
      Object var3 = null;
      String var4 = var1.getItemValueString("AllSelfMonitor");
      String var5 = var1.getItemValueString("AllTargetServers");
      Vector var6;
      if (var4 != null && var4.compareTo("1") == 0) {
         var6 = new Vector(1);
         var6.addElement(this.this_server);
      } else if (var5 != null && var5.compareTo("1") == 0) {
         var6 = var2;
      } else {
         var6 = var1.getItemValue("TargetServerName");
      }

      return var6;
   }

   private Appointment createTCPProbeAppointment(TCPProbeDoc var1, Date var2) {
      Appointment var3 = null;
      Document var4 = null;

      try {
         HostCheck var7 = new HostCheck();
         String var8 = var1.getTargetServer();
         var4 = NABUtils.getFirstDocumentFromAddressBook(notes_session, 0, var8);

         for(int var9 = 0; var9 < TCPProbeDoc.LIST_OF_SERVICES.length; ++var9) {
            if (this.isServiceEnabled(var9, var1, var4)) {
               String var10 = TCPProbeDoc.LIST_OF_SERVICES[var9];
               PortCheck var11 = (PortCheck)HostCheck.PORTCHECKHASHTABLE.get(var10);
               if (var11 != null) {
                  PortCheck var12 = (PortCheck)var11.clone();
                  if (var12 instanceof HTTPCheck) {
                     ((HTTPCheck)var12).setPath(var1.getHttpUrl());
                     InetAddress var13 = this.getIPAddress(var4, var8);
                     if (this.http_proxy_host != null && var13 != null && this.useProxy(var13, this.no_proxy_list)) {
                        ((HTTPCheck)var12).setProxy(this.http_proxy_host, this.http_proxy_port);
                     }

                     Object var26 = null;
                  }

                  if (var12 instanceof NNTPCheck) {
                     ((NNTPCheck)var12).setCommand(var1.getNntpCommand(), var1.getNntpGroup(), var1.getNntpParameters());
                  }

                  var12 = this.checkPortSettings(var4, var12);
                  if (var12 != null) {
                     var7.add(var12);
                  }
               }
            }
         }

         if (var7.getChecks().size() > 0) {
            Vector var24 = new Vector();
            var24.addElement(var7);
            var24.addElement(var1);
            if (var4 != null) {
               var24.addElement(var4.getLastModified());
            }

            var3 = new Appointment(var2, (long)(var1.getProbeInterval() * '\uea60'), var24, var1.getDescription());
         }
      } catch (Exception var19) {
         ((Throwable)var19).printStackTrace();
      } finally {
         if (var4 != null) {
            try {
               Database var22 = var4.getParentDatabase();
               var4.recycle();
               Object var21 = null;
               var22.recycle();
               Object var23 = null;
            } catch (NotesException var18) {
            }
         }

      }

      return var3;
   }

   private boolean isServiceEnabled(int var1, TCPProbeDoc var2, Document var3) {
      String var4 = TCPProbeDoc.LIST_OF_SERVICES[var1];
      String var5 = var2.getTargetServer();
      if (var3 != null) {
         if (var5.compareTo(this.this_server) == 0) {
            if (var2.allServices()) {
               return var4.compareTo("SMTP") != 0 ? this.tcp_server_tasks.contains(var4) : true;
            } else {
               return var2.isServiceEnabled(var4);
            }
         } else {
            return var2.isServiceEnabled(var4);
         }
      } else {
         return var2.isServiceEnabled(var4);
      }
   }

   private void updateStatList(Appointment var1) {
      try {
         Vector var2 = (Vector)var1.getData();
         Vector var3 = ((HostCheck)var2.elementAt(0)).getChecks();
         TCPProbeDoc var4 = (TCPProbeDoc)var2.elementAt(1);
         int var5 = var3.size();

         for(int var6 = 0; var6 < var5; ++var6) {
            PortCheck var7 = (PortCheck)var3.elementAt(var6);
            this.stat_list.addItem(var4.getStatisticName(var7.getServiceAbbreviation()));
         }

      } catch (Exception var8) {
         ((Throwable)var8).printStackTrace();
      }
   }

   private void deleteStats(Vector var1) {
      Enumeration var2 = var1.elements();

      while(var2.hasMoreElements()) {
         String var3 = (String)var2.nextElement();
         ((JavaServerAddin)this).StatDelete(this.international_string.getString("facility_id"), var3);
      }

   }

   private boolean getConfigurationData() throws NotesException {
      boolean var1 = true;
      Object var2 = null;
      notes_session = NotesFactory.createSession();
      String var3 = notes_session.getEnvironmentString("debug_ispy", true);
      if (var3 != null) {
         this.debug = new Integer(var3);
      }

      this.event_handle = notes_session.createLog("");
      this.this_server = notes_session.getUserName();
      this.this_server_abbreviated_name = this.getAbbreviatedServerName(this.this_server);
      Document var13 = NABUtils.getFirstDocumentFromAddressBook(notes_session, 0, this.this_server);
      if (var13 == null) {
         ((JavaServerAddin)this).AddInLogErrorText(this.addin_name + ": " + this.international_string.getString("no_server_record") + " " + this.this_server, 0);
         return false;
      } else {
         label82: {
            boolean var4;
            try {
               String var7 = var13.getItemValueString("Proxy_HTTP");
               if (var7 != null) {
                  int var8 = var7.indexOf(":");

                  try {
                     if (var8 != -1) {
                        this.http_proxy_host = InetAddress.getByName(var7.substring(0, var8));
                        this.http_proxy_port = Integer.parseInt(var7.substring(var8 + 1));
                     } else {
                        this.http_proxy_host = InetAddress.getByName(var7);
                     }
                  } catch (UnknownHostException var11) {
                     this.http_proxy_host = null;
                  }

                  this.no_proxy_list = var13.getItemValue("No_Proxy");
               }

               this.this_domain = var13.getItemValueString("Domain");
               if (this.this_domain != null) {
                  break label82;
               }

               var4 = false;
            } finally {
               Database var14 = var13.getParentDatabase();
               var13.recycle();
               var14.recycle();
            }

            return var4;
         }

         this.tcp_server_tasks = new TCPServerTasks(notes_session);
         return var1;
      }
   }

   private void getDatabasesAndViews() throws ISpyFatalException {
      if (this.stat_events_db == null) {
         try {
            this.stat_events_db = notes_session.getDatabase((String)null, this.STAT_EVENTS_DB_NAME);
         } catch (NotesException var5) {
            throw new ISpyFatalException(this.international_string.getString("event_db_not_found") + " = " + this.STAT_EVENTS_DB_NAME);
         }

         if (this.stat_events_db == null) {
            throw new ISpyFatalException(this.international_string.getString("event_db_not_found") + " = " + this.STAT_EVENTS_DB_NAME);
         }

         boolean var1 = false;

         for(int var2 = 0; var2 < 3; ++var2) {
            try {
               this.openDB(this.stat_events_db);
               var1 = true;
               break;
            } catch (NotesException var6) {
               try {
                  Thread.sleep(5000L);
               } catch (InterruptedException var4) {
               }

               ((JavaServerAddin)this).AddInLogErrorText(this.addin_name + ": " + this.international_string.getString("event_db_not_found") + "(" + var2 + ") = " + this.STAT_EVENTS_DB_NAME, 0);
            }
         }

         if (!var1) {
            throw new ISpyFatalException("");
         }
      }

      try {
         this.servers_view = null;
         this.servers_view = this.stat_events_db.getView("va_TCPServices");
      } catch (NotesException var3) {
      }

      if (this.servers_view == null) {
         throw new ISpyFatalException(this.international_string.getString("no_view") + " = [" + "va_TCPServices" + "]! " + this.international_string.getString("refresh_events5"));
      } else {
         this.able_to_perform_ip_probing = this.servers_view != null;
      }
   }

   public void onDoneProbingHost(HostCheckEvent var1) {
      this.host_probe_result = var1;
      ((Thread)this).resume();
   }

   public void checkResult() throws NotesException {
      if (this.current_doc != null) {
         if (this.host_probe_result != null) {
            Enumeration var2 = this.host_probe_result.elements();

            while(var2.hasMoreElements()) {
               PortCheckEvent var3 = (PortCheckEvent)var2.nextElement();
               PortCheck var4 = (PortCheck)((EventObject)var3).getSource();
               Long var1;
               if (var3.status.bitset.get(1) && var3.status.bitset.get(2) && var3.status.bitset.get(3)) {
                  var1 = new Long(var3.closeMillis - var3.openMillis);
               } else {
                  var1 = new Long(-1L);
               }

               ((JavaServerAddin)this).StatUpdate(this.international_string.getString("facility_id"), this.current_doc.getStatisticName(var4.getServiceAbbreviation()), (short)0, (short)0, var1);
               if (var1.intValue() == -1) {
                  try {
                     int var5 = 7;
                     int var6 = 2;
                     if (this.current_doc != null) {
                        var5 = TCPProbeDoc.getEventType(var4.getServiceAbbreviation());
                        var6 = this.current_doc.getSeverity();
                     }

                     this.event_handle.logEvent(this.international_string.getString("error_probe_timed_out") + this.international_string.getString("facility_id") + "." + this.current_doc.getStatisticName(var4.getServiceAbbreviation()), EVENT_QUEUE_NAME, var5, var6);
                     this.sent_event_error_messsage = false;
                  } catch (NotesException var7) {
                     if (!this.sent_event_error_messsage) {
                        ((JavaServerAddin)this).AddInLogMessageText(this.addin_name + ": " + this.international_string.getString("logevent_failure"), 0);
                     }

                     this.sent_event_error_messsage = true;
                  }
               }
            }

         }
      }
   }

   private boolean useProxy(InetAddress var1, Vector var2) {
      boolean var3 = true;
      Object var7 = null;
      Object var8 = null;
      String[] var9 = new String[2];
      int var10 = 0;
      var9[0] = var1.getHostName();
      var9[1] = var1.getHostAddress();

      while(var10 < 2 && var3) {
         Vector var5 = this.separateDomainElements(var9[var10]);

         for(int var11 = 0; var11 < var2.size(); ++var11) {
            Vector var6 = this.separateDomainElements((String)var2.elementAt(var11));
            boolean var4 = true;

            for(int var12 = 0; var12 < var6.size() && var12 != var5.size(); ++var12) {
               String var13 = ((String)var5.elementAt(var12)).toLowerCase();
               String var14 = ((String)var6.elementAt(var12)).toLowerCase();
               if (var14.compareTo(var13) != 0 && var14.compareTo("*") != 0) {
                  var4 = false;
                  break;
               }
            }

            if (var4) {
               var3 = false;
               break;
            }
         }

         if (var3) {
            ++var10;
         }
      }

      return var3;
   }

   private Vector separateDomainElements(String var1) {
      int var2 = -1;
      Vector var4 = new Vector(4);
      String var3 = var1;

      do {
         var2 = var3.lastIndexOf(".");
         if (var2 != -1) {
            var4.addElement(var3.substring(var2 + 1));
            var3 = var3.substring(0, var2);
         } else if (var3.length() > 0) {
            var4.addElement(var3);
            var3 = null;
         }
      } while(var3 != null);

      return var4;
   }

   private InetAddress getIPAddress(Document var1, String var2) {
      InetAddress var3 = null;

      try {
         var3 = InetAddress.getByName(var2);
      } catch (UnknownHostException var8) {
         if (var1 != null) {
            Vector var4;
            try {
               var4 = var1.getItemValue("NetAddresses");
            } catch (NotesException var6) {
               var4 = null;
            }

            if (var4 != null) {
               for(int var5 = 0; var5 < var4.size(); ++var5) {
                  try {
                     var3 = InetAddress.getByName((String)var4.elementAt(var5));
                     break;
                  } catch (UnknownHostException var7) {
                     var3 = null;
                  }
               }
            }
         }
      }

      return var3;
   }

   private PortCheck checkPortSettings(Document var1, PortCheck var2) {
      int var3 = 0;

      try {
         if (var1 != null) {
            if (var2 instanceof HTTPCheck) {
               if (var1.getItemValueString("HTTP_NormalMode").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("HTTP_Port");
                  if (var3 != 0) {
                     if (((HTTPCheck)var2).getProxy() != null) {
                        ((HTTPCheck)var2).setDestPort(var3);
                     } else {
                        var2.setPort(var3);
                     }
                  }
               } else {
                  var2 = null;
               }
            }

            if (var2 instanceof NNTPCheck) {
               if (var1.getItemValueString("NNTP_PortStatus").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("NNTP_Port");
                  if (var3 != 0) {
                     var2.setPort(var3);
                  }
               } else {
                  var2 = null;
               }
            }

            if (var2 instanceof LDAPCheck) {
               if (var1.getItemValueString("LDAP_PortStatus").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("LDAP_Port");
                  if (var3 != 0) {
                     var2.setPort(var3);
                  }
               } else {
                  var2 = null;
               }
            }

            if (var2 instanceof POP3Check) {
               if (var1.getItemValueString("POP3_PortStatus").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("POP3_Port");
                  if (var3 != 0) {
                     var2.setPort(var3);
                  }
               } else {
                  var2 = null;
               }
            }

            if (var2 instanceof IMAP4Check) {
               if (var1.getItemValueString("IMAP_PortStatus").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("IMAP_Port");
                  if (var3 != 0) {
                     var2.setPort(var3);
                  }
               } else {
                  var2 = null;
               }
            }

            if (var2 instanceof SMTPCheck) {
               if (var1.getItemValueString("SMTP_PortStatus").compareTo("1") == 0 && var1.getItemValueString("SMTPListenerEnabled").compareTo("1") == 0) {
                  var3 = var1.getItemValueInteger("SMTP_Port");
                  if (var3 != 0) {
                     var2.setPort(var3);
                  }
               } else {
                  var2 = null;
               }
            }
         }
      } catch (Exception var4) {
         var2 = null;
      }

      return var2;
   }

   private String getAbbreviatedServerName(String var1) throws NotesException {
      Name var2 = notes_session.createName(var1);
      String var3 = var2.getAbbreviated();
      var2.recycle();
      Object var4 = null;
      return var3;
   }

   private boolean openDB(Database var1) throws NotesException {
      return !var1.isOpen() ? var1.open() : false;
   }

   private void sleep(Date var1) throws InterruptedException {
      if (!((JavaServerAddin)this).shouldTerminate()) {
         long var2 = 0L;
         if (var1 == null) {
            var2 = (long)this.DEFAULT_POLL_TIME;
         } else {
            var2 = var1.getTime() - System.currentTimeMillis();
            if (var2 < 0L) {
               var2 = 0L;
            } else if (var2 > (long)this.DEFAULT_POLL_TIME) {
               var2 = (long)this.DEFAULT_POLL_TIME;
            }
         }

         Thread.sleep(var2);
      }

   }
}
