package lotus.notes.addins.ispy.net;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

public class BinaryConnection extends Connection {
   public static final int INPUT_STREAM = 1;
   public static final int OUTPUT_STREAM = 2;
   private static final int MASK_BYTE = 255;
   private BufferedInputStream m_in;
   private BufferedOutputStream m_out;

   public static void toUnsigned16(int var0, byte[] var1, int var2) throws IOException {
      var1[var2] = (byte)(var0 / 256);
      var1[var2 + 1] = (byte)(var0 % 256);
   }

   public static int parseUnsigned16(byte[] var0, int var1) {
      int var2 = (var0[var1] & 255) * 256;
      int var3 = var0[var1 + 1] & 255;
      return var2 + var3;
   }

   public static String toHexString(byte[] var0) {
      return toHexString(var0, 0);
   }

   public static String toHexString(byte[] var0, int var1) {
      StringBuffer var2 = new StringBuffer(3 * (var0.length - var1));

      for(int var3 = var1; var3 < var0.length; ++var3) {
         if (var3 > var1) {
            var2.append(' ');
         }

         var2.append(Integer.toHexString(var0[var3] & 255));
      }

      return var2.toString();
   }

   public void open(InetAddress var1, int var2, int var3, int var4) throws IOException {
      Socket var5 = super.open(var1, var2, var3);
      if ((var4 & 1) != 0) {
         this.m_in = new BufferedInputStream(var5.getInputStream());
         if (this.m_in == null) {
            throw new IOException("BinaryConnection.open() BufferedInputStream == null");
         }
      }

      if ((var4 & 2) != 0) {
         this.m_out = new BufferedOutputStream(var5.getOutputStream());
         if (this.m_out == null) {
            throw new IOException("BinaryConnection.open() BufferedOutputStream == null");
         }
      }

   }

   public void write(byte[] var1) throws IOException {
      this.m_out.write(var1);
   }

   public void writeUnsigned16(int var1) throws IOException {
      byte[] var2 = new byte[2];
      toUnsigned16(var1, var2, 0);
      this.m_out.write(var2);
   }

   public void flush() throws IOException {
      this.m_out.flush();
   }

   public int available() throws IOException {
      return this.m_in.available();
   }

   public int read(byte[] var1, int var2, int var3) throws IOException {
      return this.m_in.read(var1, var2, var3);
   }

   public int readUnsigned16() throws IOException {
      byte[] var1 = new byte[2];
      this.m_in.read(var1, 0, 2);
      return parseUnsigned16(var1, 0);
   }
}
