package lotus.notes.addins.ispy.net;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Vector;

public class TextConnection extends Connection {
   public static final String CLIENT_PREFIX = "C:";
   public static final String SERVER_PREFIX = "S:";
   public static final int CLIENT_PREFIX_LENGTH = "C:".length();
   public static final int SERVER_PREFIX_LENGTH = "S:".length();
   public static final String CRLF = "\r\n";
   protected Vector m_transactions = new Vector(10);
   private BufferedReader m_in;
   private PrintWriter m_out;

   public void open(InetAddress var1, int var2, int var3, int var4) throws IOException {
      Socket var5 = super.open(var1, var2, var3);
      if ((var4 & 1) != 0) {
         this.m_in = new BufferedReader(new InputStreamReader(var5.getInputStream()));
         if (this.m_in == null) {
            throw new IOException("PortCheck.open() BufferedReader == null");
         }
      }

      if ((var4 & 2) != 0) {
         this.m_out = new PrintWriter(new OutputStreamWriter(var5.getOutputStream()));
         if (this.m_out == null) {
            throw new IOException("PortCheck.open() PrintWriter == null");
         }
      }

   }

   public String readLine() throws IOException {
      String var1 = this.m_in.readLine();
      this.m_transactions.addElement("S:" + var1);
      return var1;
   }

   public void println(String var1) throws IOException {
      this.m_transactions.addElement("C:" + var1);
      this.m_out.print(var1);
      this.m_out.print("\r\n");
   }

   public void println() throws IOException {
      this.m_transactions.addElement("C:");
      this.m_out.print("\r\n");
   }

   public void print(String var1) throws IOException {
      this.m_transactions.addElement("C:");
      this.m_out.print(var1);
   }

   public void flush() throws IOException {
      this.m_out.flush();
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer(this.m_transactions.size() * 20);

      for(int var2 = 0; var2 < this.m_transactions.size(); ++var2) {
         var1.append(this.m_transactions.elementAt(var2));
         var1.append('\n');
      }

      return var1.toString();
   }

   public static boolean test(PrintStream var0) {
      byte var1 = 7;
      TextConnection var2 = new TextConnection();
      var0.println(var2.getClass().getName());

      try {
         String var3 = "Hello World";
         Object var4 = null;
         var0.print(".open(InetAddress, int, int) - ");
         var2.open(InetAddress.getLocalHost(), var1, 1000, 3);
         var0.println(true);
         var0.print(".println(String) - ");
         var2.println(var3);
         var0.println(true);
         var0.print(".flush() - ");
         var2.flush();
         var0.println(true);
         var0.print(".readLine() - ");
         String var6 = var2.readLine();
         var0.println(true);
         var0.print(".close() - ");
         ((Connection)var2).close();
         var0.println(true);
         return var3.equals(var6);
      } catch (IOException var5) {
         var0.println(false);
         var0.println("Exception: " + ((Throwable)var5).getMessage());
         return false;
      }
   }
}
