package lotus.notes.addins.ispy.net.dns;

import java.io.PrintStream;
import lotus.notes.addins.ispy.net.BinaryConnection;

public class DNSNameTypeClass {
   public static final int RRTYPE_A = 1;
   public static final int RRTYPE_NS = 2;
   public static final int RRTYPE_MD = 3;
   public static final int RRTYPE_MF = 4;
   public static final int RRTYPE_CNAME = 5;
   public static final int RRCLASS_IN = 1;
   public static final int RRCLASS_CS = 2;
   public static final int RRCLASS_CH = 3;
   public static final int RRCLASS_HS = 4;
   public static final int RRCLASS_WILD = 255;
   private String m_dname;
   private int m_rrtype;
   private int m_rrclass;

   public DNSNameTypeClass(String var1, int var2, int var3) {
      this.m_dname = var1;
      this.m_rrtype = var2;
      this.m_rrclass = var3;
   }

   public synchronized byte[] toByteArray() {
      int var1 = this.m_dname.length();
      byte[] var2 = new byte[1 + var1 + 1 + 2 + 2];
      int var3 = 0;
      int var4 = 0;
      int var5 = this.m_dname.indexOf(46);
      if (var5 == -1) {
         var5 = var1;
      }

      while(var4 < var1) {
         var2[var3] = (byte)(var5 - var4);
         ++var3;

         for(int var6 = var4; var6 < var5; ++var6) {
            var2[var3] = (byte)this.m_dname.charAt(var6);
            ++var3;
         }

         var4 = var5 + 1;
         var5 = this.m_dname.indexOf(46, var4);
         if (var5 == -1) {
            var5 = var1;
         }
      }

      var2[var3] = 0;
      ++var3;
      var2[var3] = (byte)(this.m_rrtype / 256);
      ++var3;
      var2[var3] = (byte)(this.m_rrtype % 256);
      ++var3;
      var2[var3] = (byte)(this.m_rrclass / 256);
      ++var3;
      var2[var3] = (byte)(this.m_rrclass % 256);
      ++var3;
      return var2;
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer(5 + this.m_dname.length() + 6 + 5 + 7 + 5);
      var1.append("NAME=");
      var1.append(this.m_dname);
      var1.append("\nTYPE=");
      var1.append(Integer.toString(this.m_rrtype));
      var1.append("\nCLASS=");
      var1.append(Integer.toString(this.m_rrclass));
      return var1.toString();
   }

   public String toHexString() {
      byte[] var1 = this.toByteArray();
      return BinaryConnection.toHexString(var1);
   }

   public static boolean test(PrintStream var0) {
      boolean var1 = true;
      DNSNameTypeClass var2 = new DNSNameTypeClass("lotus.com", 1, 1);
      var0.println(var2.getClass().getName());
      var0.print(".toString() - ");
      String var3 = "NAME=lotus.com\nTYPE=1\nCLASS=1";
      if (!var3.equals(var2.toString())) {
         var0.println("FAILED - " + var2.toString());
         var1 = false;
      } else {
         var0.println("PASSED");
      }

      var0.print(".toByteArray() - ");
      byte[] var4 = var2.toByteArray();
      byte[] var5 = new byte[]{5, 108, 111, 116, 117, 115, 3, 99, 111, 109, 0, 0, 1, 0, 1};
      boolean var6 = var4.length == var5.length;
      if (var6) {
         for(int var7 = 0; var7 < var4.length; ++var7) {
            if (var4[var7] != var5[var7]) {
               var6 = false;
            }
         }
      }

      if (!var6) {
         var0.println("FAILED - " + var2.toHexString());
      } else {
         var0.println("PASSED");
      }

      return var1;
   }

   public static void main(String[] var0) {
      test(System.out);
   }
}
