package lotus.notes.addins.ispy.net.portcheck;

import java.io.IOException;
import lotus.notes.addins.ispy.net.BinaryConnection;
import lotus.notes.addins.ispy.net.Connection;
import lotus.notes.addins.ispy.net.dns.DNSHeader;
import lotus.notes.addins.ispy.net.dns.DNSNameTypeClass;

public class DNSCheck extends BinaryPortCheck {
   public static final int PORT = 53;

   public DNSCheck() {
      super("Domain Name System", "DNS", 53);
   }

   public void converse(Connection var1, PortCheckEvent var2) {
      int var3 = (int)(System.currentTimeMillis() % 256L);
      String var4 = super.m_host.getHostName();

      try {
         var2.status.bitset.set(1);
         var2.openMillis = System.currentTimeMillis();
         var1.open(((PortCheck)this).getHost(), ((PortCheck)this).getPort(), ((PortCheck)this).getTimely(), 3);
         var2.status.bitset.set(2);
         DNSHeader var5 = new DNSHeader(var3, false, 0, false, false, true, false, 0, 1, 0, 0, 0);
         byte[] var6 = var5.toByteArray();
         DNSNameTypeClass var7 = new DNSNameTypeClass(var4, 1, 1);
         byte[] var8 = var7.toByteArray();
         int var9 = var6.length + var8.length;
         BinaryConnection var10 = (BinaryConnection)var1;
         var10.writeUnsigned16(var9);
         var10.write(var6);
         var10.write(var8);
         var10.flush();
         var9 = var10.readUnsigned16();
         byte[] var11 = new byte[var9];
         var10.read(var11, 0, var9);
         var5 = new DNSHeader(var11, 0);
         if (var5.getId() == var3 && var5.getQr() && var5.getOpcode() == 0) {
            var2.status.bitset.set(3);
         }

         ((Connection)var10).close();
         var2.closeMillis = System.currentTimeMillis();
      } catch (IOException var12) {
         var2.closeMillis = System.currentTimeMillis();
         var2.message = ((Throwable)var12).getMessage();
      }

      if (var2.closeMillis - var2.openMillis <= (long)super.m_timely) {
         var2.status.bitset.set(4);
      }

   }
}
