package lotus.notes.addins.ispy.net.portcheck;

import java.net.InetAddress;
import java.text.MessageFormat;
import lotus.notes.addins.ispy.net.Connection;

public class HTTPCheck extends TextPortCheck {
   public static final int PORT = 80;
   public static final String ABBREVIATION = "HTTP";
   public static final String HEAD_URL = "//";
   public static final String CLIENT_TRANSACTION = "C:GET {0}{1} HTTP/1.0\n";
   public static final String SERVER_TRANSACTION = "S:HTTP/";
   private InetAddress m_proxy;
   private String m_path;
   private int m_dest_port = -1;

   public HTTPCheck() {
      super("Hypertext Transfer Protocol", "HTTP", 80);
   }

   public void setProxy(InetAddress var1, int var2) {
      this.m_proxy = var1;
      ((PortCheck)this).setPort(var2);
   }

   public void setPath(String var1) {
      if (var1 != null) {
         if (var1.startsWith("/")) {
            this.m_path = var1;
            return;
         }

         this.m_path = "/" + var1;
      }

   }

   public void setDestPort(int var1) {
      this.m_dest_port = var1;
   }

   public InetAddress getProxy() {
      return this.m_proxy;
   }

   public void start(PortCheckListener var1, InetAddress var2, int var3) {
      String[] var4 = new String[2];
      Object[] var5 = new Object[2];
      InetAddress var6;
      if (this.m_proxy == null) {
         var6 = var2;
         var5[0] = new String("");
         var5[1] = new String("//");
      } else {
         var6 = this.m_proxy;
         if (this.m_dest_port != -1) {
            var5[0] = new String("http://" + var2.getHostAddress() + ":" + this.m_dest_port);
         } else {
            var5[0] = new String("http://" + var2.getHostAddress());
         }

         var5[1] = new String("/");
      }

      if (this.m_path != null) {
         var5[1] = new String(this.m_path);
      }

      var4[0] = MessageFormat.format("C:GET {0}{1} HTTP/1.0\n", var5);
      var4[1] = "S:HTTP/";
      super.start(var1, var6, var3, var4);
   }

   protected void converse(Connection var1, PortCheckEvent var2) {
      super.converse(var1, var2);
      if (var2.status.bitset.get(3)) {
         boolean var3 = true;

         for(int var4 = 0; var4 < var2.transactions.length; ++var4) {
            if (var2.transactions[var4].startsWith("S:HTTP/")) {
               int var5 = var2.transactions[var4].indexOf(32);
               int var6 = var2.transactions[var4].indexOf(32, var5 + 1);
               int var7 = Integer.valueOf(var2.transactions[var4].substring(var5 + 1, var6));
               if (var7 < 500 && var7 != 400) {
                  if (this.m_path != null && var7 != 200) {
                     var3 = false;
                     var2.message = var2.transactions[var4];
                  }
                  break;
               }

               var3 = false;
               var2.message = var2.transactions[var4];
               break;
            }
         }

         if (!var3) {
            var2.status.bitset.clear(3);
         }
      }

   }
}
