package lotus.notes.addins.ispy.net.portcheck;

import java.net.InetAddress;
import java.util.Hashtable;
import java.util.Vector;

public class HostCheck implements Runnable, PortCheckListener {
   public static PortCheck[] PORTCHECKARRAY = new PortCheck[]{new DAYTIMECheck(), new DNSCheck(), new ECHOCheck(), new FINGERCheck(), new FTPCheck(), new HTTPCheck(), new IMAP4Check(), new LDAPCheck(), new MTAPCheck(), new NNTPCheck(), new POP3Check(), new SMTPCheck(), new STAMPCheck(), new TELNETCheck()};
   public static final Hashtable PORTCHECKHASHTABLE;
   public static final HostCheck HOSTCHECK;
   private Vector m_checks = new Vector(12);
   private HostCheckTimeout m_timeout = new HostCheckTimeout();
   private Thread m_thread;
   private HostCheckListener m_listener;
   protected int m_timeoutMillis = -1;
   protected InetAddress m_host;
   protected int m_slowMillis = -1;
   private HostCheckEvent m_result;

   public InetAddress getHost() {
      return this.m_host;
   }

   public void add(PortCheck var1) {
      this.m_checks.addElement(var1);
   }

   public void start(HostCheckListener var1, int var2, InetAddress var3, int var4) {
      this.m_listener = var1;
      this.m_timeoutMillis = var2;
      this.m_host = var3;
      this.m_slowMillis = var4;
      this.m_thread = new Thread(this);
      this.m_thread.start();
   }

   public void stop() {
      if (this.m_thread != null) {
         this.m_thread.stop();
      }

      this.m_thread = null;
      this.m_host = null;
   }

   public void run() {
      this.m_result = new HostCheckEvent(this, this.m_checks.size());
      int var1 = this.m_checks.size();

      for(int var2 = 0; var2 < var1; ++var2) {
         PortCheck var3 = (PortCheck)this.m_checks.elementAt(var2);
         var3.start(this, this.m_host, this.m_slowMillis);
      }

      this.m_timeout.start(this, this.m_timeoutMillis);
      long var8 = System.currentTimeMillis();
      this.m_thread.suspend();
      this.m_timeout.stop();

      for(int var5 = 0; var5 < var1; ++var5) {
         PortCheck var6 = (PortCheck)this.m_checks.elementAt(var5);
         var6.stop();
         if (!this.m_result.contains(var6)) {
            PortCheckEvent var7 = PortCheckEvent.getTimeout(var6, var8, this.m_timeoutMillis);
            this.m_result.add(var7);
         }
      }

      this.m_listener.onDoneProbingHost(this.m_result);
      this.m_result = null;
   }

   void timeout() {
      this.m_thread.resume();
   }

   public void checkResult(PortCheckEvent var1) {
      this.m_result.add(var1);
      if (this.m_result.size() >= this.m_checks.size()) {
         this.m_thread.resume();
      }

   }

   public Object clone() {
      HostCheck var1 = new HostCheck();
      var1.m_checks = (Vector)this.m_checks.clone();
      return var1;
   }

   public Vector getChecks() {
      return (Vector)this.m_checks.clone();
   }

   static {
      PORTCHECKHASHTABLE = new Hashtable(PORTCHECKARRAY.length);
      HOSTCHECK = new HostCheck();

      for(int var0 = 0; var0 < PORTCHECKARRAY.length; ++var0) {
         PortCheck var1 = PORTCHECKARRAY[var0];
         PORTCHECKHASHTABLE.put(var1.getServiceAbbreviation(), var1);
         HOSTCHECK.add(var1);
      }

   }
}
