package lotus.notes.addins.ispy.net.portcheck;

import java.util.Enumeration;
import java.util.EventObject;
import java.util.Vector;

public class HostCheckEvent extends EventObject {
   private Vector m_results;
   public long earliestMillis = -1L;
   public long latestMillis = -1L;
   public Vector m_alerts = new Vector();

   public HostCheckEvent(HostCheck var1, int var2) {
      super(var1);
      this.m_results = new Vector(var2);
   }

   public synchronized void add(PortCheckEvent var1) {
      this.m_results.addElement(var1);
      if (this.earliestMillis == -1L) {
         this.earliestMillis = var1.openMillis;
         this.latestMillis = var1.closeMillis;
      } else {
         if (var1.openMillis < this.earliestMillis) {
            this.earliestMillis = var1.openMillis;
         }

         if (var1.closeMillis > this.latestMillis) {
            this.latestMillis = var1.closeMillis;
         }

      }
   }

   public synchronized int size() {
      return this.m_results.size();
   }

   public String toString() {
      int var1 = this.m_results.size();
      StringBuffer var2 = new StringBuffer(var1 * 80);

      for(int var3 = 0; var3 < var1; ++var3) {
         PortCheckEvent var4 = (PortCheckEvent)this.m_results.elementAt(var3);
         var2.append(var4.toString());
         var2.append('\n');
      }

      return var2.toString();
   }

   public Enumeration elements() {
      return this.m_results.elements();
   }

   public boolean contains(PortCheck var1) {
      int var2 = this.m_results.size();

      for(int var3 = 0; var3 < var2; ++var3) {
         PortCheckEvent var4 = (PortCheckEvent)this.m_results.elementAt(var3);
         if (var1 == ((EventObject)var4).getSource()) {
            return true;
         }
      }

      return false;
   }
}
