package lotus.notes.addins.ispy.net.portcheck;

import java.io.IOException;
import lotus.notes.addins.ispy.net.BinaryConnection;
import lotus.notes.addins.ispy.net.Connection;

public class LDAPCheck extends BinaryPortCheck {
   public static final int PORT = 389;

   public LDAPCheck() {
      super("Lightweight Directory Access Protocol", "LDAP", 389);
   }

   public void converse(Connection var1, PortCheckEvent var2) {
      try {
         var2.status.bitset.set(1);
         var2.openMillis = System.currentTimeMillis();
         var1.open(((PortCheck)this).getHost(), ((PortCheck)this).getPort(), ((PortCheck)this).getTimely(), 3);
         var2.status.bitset.set(2);
         byte[] var3 = new byte[]{48, 12, 2, 1, 0, 96, 7, 2, 1, 2, 4, 0, -128, 0};
         BinaryConnection var4 = (BinaryConnection)var1;
         var4.write(var3);
         var4.flush();
         var4.read(var3, 0, var3.length);
         if (var3[0] == 48) {
            if ((var3[1] & -128) == 0) {
               if (var3[5] == 97) {
                  var2.status.bitset.set(3);
               }
            } else if (var3[9] == 97) {
               var2.status.bitset.set(3);
            }
         }

         ((Connection)var4).close();
         var2.closeMillis = System.currentTimeMillis();
      } catch (IOException var5) {
         var2.closeMillis = System.currentTimeMillis();
         var2.message = ((Throwable)var5).getMessage();
      }

      if (var2.closeMillis - var2.openMillis <= (long)super.m_timely) {
         var2.status.bitset.set(4);
      }

   }
}
