package lotus.notes.addins.ispy.net.portcheck;

import java.net.InetAddress;
import lotus.notes.addins.ispy.net.BinaryConnection;
import lotus.notes.addins.ispy.net.Connection;
import lotus.notes.addins.ispy.net.TextConnection;

public class PortCheck implements Runnable {
   private String m_name;
   private String m_abbreviation;
   private int m_port = -1;
   private boolean m_text = true;
   private Thread m_thread;
   private PortCheckListener m_listener;
   protected InetAddress m_host;
   protected int m_timely = -1;
   protected String[] m_expected;
   private Connection m_connection;

   protected PortCheck(String var1, String var2, int var3, boolean var4) {
      this.m_name = var1;
      this.m_abbreviation = var2;
      this.m_port = var3;
      this.m_text = var4;
   }

   public void setPort(int var1) {
      this.m_port = var1;
   }

   public String getServiceName() {
      return this.m_name;
   }

   public String getServiceAbbreviation() {
      return this.m_abbreviation;
   }

   public int getPort() {
      return this.m_port;
   }

   public InetAddress getHost() {
      return this.m_host;
   }

   public int getTimely() {
      return this.m_timely;
   }

   public void start(PortCheckListener var1, InetAddress var2, int var3) {
      this.start(var1, var2, var3, (String[])null);
   }

   protected void start(PortCheckListener var1, InetAddress var2, int var3, String[] var4) {
      this.m_listener = var1;
      this.m_host = var2;
      this.m_timely = var3;
      this.m_expected = var4;
      this.m_thread = new Thread(this);
      this.m_thread.start();
   }

   protected void converse(Connection var1, PortCheckEvent var2) {
   }

   public void run() {
      PortCheckEvent var1 = new PortCheckEvent(this, this.m_expected);
      if (this.m_text) {
         this.m_connection = new TextConnection();
      } else {
         this.m_connection = new BinaryConnection();
      }

      var1.openMillis = System.currentTimeMillis();
      this.converse(this.m_connection, var1);
      var1.closeMillis = System.currentTimeMillis();
      this.m_listener.checkResult(var1);
   }

   public void stop() {
      if (this.m_thread != null) {
         this.m_thread.stop();
      }

      this.m_thread = null;
      if (this.m_connection != null) {
         try {
            this.m_connection.close();
         } catch (Exception var1) {
         }

         this.m_connection = null;
      }

   }

   public Object clone() {
      try {
         Object var1 = this.getClass().newInstance();
         return var1;
      } catch (InstantiationException var2) {
         return null;
      } catch (IllegalAccessException var3) {
         return null;
      }
   }
}
