package lotus.notes.addins.ispy.net.portcheck;

import java.io.IOException;
import java.net.InetAddress;
import lotus.notes.addins.ispy.net.Connection;
import lotus.notes.addins.ispy.net.TextConnection;

public abstract class TextPortCheck extends PortCheck {
   protected static final String[] RECEIVE_ONLY_TRANSACTION = new String[]{"S:"};

   protected TextPortCheck(String var1, String var2, int var3) {
      super(var1, var2, var3, true);
   }

   public void start(PortCheckListener var1, InetAddress var2, int var3) {
      super.start(var1, var2, var3, RECEIVE_ONLY_TRANSACTION);
   }

   protected void start(PortCheckListener var1, InetAddress var2, int var3, String[] var4) {
      super.start(var1, var2, var3, var4);
   }

   protected void converse(Connection var1, PortCheckEvent var2) {
      var2.status.bitset.set(1);

      try {
         int var3 = 0;

         for(int var4 = 0; var4 < super.m_expected.length; ++var4) {
            if (super.m_expected[var4].startsWith("S:")) {
               var3 |= 1;
            } else if (super.m_expected[var4].startsWith("C:")) {
               var3 |= 2;
            }
         }

         var2.openMillis = System.currentTimeMillis();
         var1.open(((PortCheck)this).getHost(), ((PortCheck)this).getPort(), ((PortCheck)this).getTimely(), var3);
         var2.status.bitset.set(2);
         boolean var5 = true;
         TextConnection var6 = (TextConnection)var1;

         for(int var7 = 0; var7 < super.m_expected.length; ++var7) {
            if (super.m_expected[var7].startsWith("C:")) {
               var2.transactions[var7] = super.m_expected[var7];
               var6.println(super.m_expected[var7].substring("C:".length()));
               var6.flush();
            } else if (super.m_expected[var7].startsWith("S:")) {
               var2.transactions[var7] = "S:" + var6.readLine();
               if (!var2.transactions[var7].startsWith(super.m_expected[var7])) {
                  var5 = false;
                  var2.message = var2.transactions[var7];
                  break;
               }
            }
         }

         if (var5) {
            var2.status.bitset.set(3);
         }

         var1.close();
         var2.closeMillis = System.currentTimeMillis();
      } catch (IOException var8) {
         var2.closeMillis = System.currentTimeMillis();
         var2.message = ((Throwable)var8).getMessage();
      }

      if (var2.closeMillis - var2.openMillis <= (long)super.m_timely) {
         var2.status.bitset.set(4);
      }

   }
}
