package lotus.notes.addins.ispy.util;

import java.util.Date;

public class Appointment {
   private boolean active;
   private Date appointment_date;
   private long repetition_interval;
   private Object user_data;
   private String description;

   public Appointment(Date var1, long var2, Object var4, String var5) {
      this.appointment_date = var1;
      this.repetition_interval = var2;
      this.user_data = var4;
      this.description = var5;
      this.active = true;
   }

   public Appointment(long var1, Object var3, String var4) {
      this.appointment_date = new Date();
      this.appointment_date.setTime(this.appointment_date.getTime() + var1);
      this.repetition_interval = var1;
      this.user_data = var3;
      this.description = var4;
      this.active = true;
   }

   public Date getDate() {
      return this.appointment_date;
   }

   public boolean repeats() {
      return this.repetition_interval != 0L;
   }

   public long getRepetitionInterval() {
      return this.repetition_interval;
   }

   public Object getData() {
      return this.user_data;
   }

   public String getDescription() {
      return this.description;
   }

   public void setDate(Date var1) {
      this.appointment_date = var1;
   }

   public void setRepetitionInterval(long var1) {
      this.repetition_interval = var1;
   }

   public void setData(Object var1) {
      this.user_data = var1;
   }

   public void setDescription(String var1) {
      this.description = var1;
   }

   public void repeat() {
      long var1 = this.appointment_date.getTime() + this.repetition_interval;
      this.appointment_date = new Date();
      this.appointment_date.setTime(var1);
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append(this.appointment_date.toString());
      var1.append(" ");
      var1.append(Long.toString(this.repetition_interval));
      var1.append(" ");
      var1.append(this.description);
      return var1.toString();
   }

   public void activate() {
      this.active = true;
   }

   public void deActivate() {
      this.active = false;
   }

   public boolean isActive() {
      return this.active;
   }
}
