package lotus.notes.apps.reports;

import java.text.Format;
import java.text.MessageFormat;
import java.util.Locale;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;
import lotus.notes.JavaString;

public class InternationalResources {
   private PropertyResourceBundle resource;
   private JavaString agent_resources = new JavaString("lotus.notes.AgentResources");

   public InternationalResources(String var1) {
      Object var2 = null;

      try {
         if (System.getProperty("user.region") == null) {
            var4 = new Locale(System.getProperty("user.language"), "");
         } else {
            var4 = new Locale(System.getProperty("user.language"), System.getProperty("user.region"));
         }
      } catch (Exception var3) {
         System.err.println("JVM unable to obtain system locale. Defaulting to English.");
         var4 = new Locale("en", "US");
      }

      this.resource = (PropertyResourceBundle)ResourceBundle.getBundle(var1, var4);
   }

   public String getString(String var1) {
      return this.resource.getString(var1);
   }

   public String getFormattedString(String var1, String var2, String var3) {
      Object[] var4 = new Object[]{var2, var3};
      MessageFormat var5 = new MessageFormat(this.resource.getString(var1));
      return ((Format)var5).format(var4);
   }

   public String getFormattedString(String var1, String var2) {
      Object[] var3 = new Object[]{var2};
      MessageFormat var4 = new MessageFormat(this.resource.getString(var1));
      return ((Format)var4).format(var3);
   }
}
