package lotus.notes.apps.reports;

import java.io.File;
import java.util.Enumeration;
import java.util.MissingResourceException;
import java.util.StringTokenizer;
import java.util.Vector;
import lotus.domino.AgentBase;
import lotus.domino.AgentContext;
import lotus.domino.Database;
import lotus.domino.Document;
import lotus.domino.DocumentCollection;
import lotus.domino.NotesException;
import lotus.domino.Session;

public class RepAgent extends AgentBase {
   private String debug;
   private InternationalResources international_string;
   public Session mSession;
   public AgentContext mContext;

   native String NdoReport(String var1, int var2, String var3, String var4, String var5);

   native String NgetTempPath();

   native void NputChartInDoc(String var1, int var2, String var3, String var4);

   public void NotesMain() {
      try {
         this.international_string = new InternationalResources("lotus/notes/apps/reports/ReportsResources");
         this.mSession = ((AgentBase)this).getSession();
         this.mContext = this.mSession.getAgentContext();
         this.debug = this.mSession.getEnvironmentString(this.international_string.getString("ini_debug_string"), true);
         this.makeReports();
      } catch (Exception var2) {
         ((Throwable)var2).printStackTrace();
      }
   }

   public void makeReports() {
      Object var1 = null;
      Object var2 = null;
      Object var3 = null;

      Database var4;
      DocumentCollection var5;
      int var6;
      try {
         var4 = this.mContext.getCurrentDatabase();
         var5 = this.mContext.getUnprocessedDocuments();
         var23 = var4.getServer();
         var24 = var4.getFilePath();
         var25 = this.international_string.getString("mtstore_db");
         var6 = var5.getCount();
         if (this.debug != null) {
            System.out.println("Username = " + this.mContext.getEffectiveUserName());
         }

         if (this.debug != null) {
            System.out.println("Agent Name = " + this.mContext.getCurrentAgent().getName());
         }

         if (this.debug != null) {
            System.out.println("Documents to process = " + var6);
         }
      } catch (Exception var22) {
         ((Throwable)var22).printStackTrace();
         return;
      }

      for(int var7 = 1; var7 <= var6; ++var7) {
         try {
            if (this.debug != null) {
               System.out.println("Processing document #" + var7);
            }

            Document var8 = var5.getNthDocument(var7);
            this.mContext.updateProcessedDoc(var8);
            String var9 = var8.getItemValueString("ReportGenInterval");
            if (var9 != null) {
               if (var9.compareTo("ka_Once") != 0) {
                  if (this.debug != null) {
                     System.out.println("Scheduled report.");
                  }

                  if (this.mContext.getCurrentAgent().getName().indexOf("aa_WebOneTimeReportAgent") != -1) {
                     continue;
                  }

                  Document var10 = var4.createDocument();
                  var8.copyAllItems(var10, true);
                  var8 = var10;
               } else {
                  if (this.debug != null) {
                     System.out.println("One-time report.");
                  }

                  String var26 = this.mSession.getEnvironmentString("ReportRequestID", false);
                  if (this.debug != null) {
                     System.out.println("ini_id = " + var26);
                  }

                  String var11 = var8.getItemValueString("ReportRequestID");
                  if (this.debug != null) {
                     System.out.println("doc_id = " + var11);
                  }

                  if (var26 != null && var26.compareTo(var11) != 0) {
                     if (this.debug != null) {
                        System.out.println("This document was created by someone else.");
                     }
                     continue;
                  }
               }

               var8.replaceItemValue("Type", "ka_Response");
               var8.save(true);
               RepQuery var27 = new RepQuery(this, var8, var4);
               if (this.debug != null) {
                  System.out.println("new ReqQuery =" + var27.toString());
               }

               if (var27 != null && var27.getReportId() != null) {
                  String var28 = null;
                  String var12 = null;
                  boolean var13 = true;
                  if (this.debug != null) {
                     System.out.println("BEFORE: issueRequest");
                  }

                  try {
                     var28 = this.issueRequest(var27, var8, var23, var24, var25);
                  } catch (Exception var18) {
                     var13 = false;
                     var12 = ((Throwable)var18).getMessage();
                  }

                  String var14 = var8.getUniversalID();
                  var8.recycle();
                  var8 = var4.getDocumentByUNID(var14);
                  if (this.debug != null) {
                     System.out.println("AFTER : issueRequest");
                  }

                  if (var13) {
                     if (var28 != null && var28.length() > 0) {
                        if (this.debug != null) {
                           System.out.println("BEFORE: makeRowsFromCsv");
                        }

                        Vector var15 = this.makeRowsFromCsv(var28);
                        if (this.debug != null) {
                           System.out.println("AFTER : makeRowsFromCsv");
                        }

                        if (var27.getReportId() != null && var27.getReportId() != 11) {
                           if (this.debug != null) {
                              System.out.println("BEFORE: makeChart");
                           }

                           try {
                              this.makeChart(var27, var8, var15, var23, var24);
                           } catch (Exception var20) {
                              var12 = ((Throwable)var20).getMessage();
                              if (var12 != null) {
                                 if (this.debug != null) {
                                    System.out.println("Error returned from makeChart = " + var12);
                                 }

                                 ((Throwable)var20).printStackTrace();

                                 try {
                                    var8.replaceItemValue("ReportChart", this.international_string.getString(var12));
                                 } catch (MissingResourceException var17) {
                                    var8.replaceItemValue("ReportChart", this.international_string.getString("error_gif_failed"));
                                 }

                                 var8.save(true);
                              } else {
                                 var8.replaceItemValue("ReportChart", this.international_string.getString("error_request_failed"));
                                 var8.save(true);
                              }
                           }

                           if (this.debug != null) {
                              System.out.println("AFTER : makeChart");
                           }
                        }
                     } else {
                        var8.replaceItemValue("ReportChart", this.international_string.getString("no_responses"));
                        var8.save(true);
                     }
                  } else if (var12 != null) {
                     var8.replaceItemValue("ReportChart", this.international_string.getString(var12));
                     var8.save(true);
                  } else {
                     var8.replaceItemValue("ReportChart", this.international_string.getString("error_request_failed"));
                     var8.save(true);
                  }
               }

               var8.save(true);
               String var29 = var8.getItemValueString("ResultDisposition");
               if (var29.compareTo("ka_Saved") != 0) {
                  Vector var31 = var8.getItemValue("MailRecipient");
                  if (this.debug != null) {
                     for(int var32 = 0; var32 < var31.size(); ++var32) {
                        if (this.debug != null) {
                           System.out.println("Send mail message to " + (String)var31.elementAt(var32));
                        }
                     }
                  }

                  try {
                     RepDef var33 = RepDef.getDef(var27.getReportId());
                     var8.appendItemValue("Subject", var33.getDisplayName());
                     var8.send(true, var31);
                     if (var9.compareTo("ka_Once") != 0) {
                        var8.remove(true);
                        if (this.debug != null) {
                           System.out.println("Deleted Scheduled report that was mailed.");
                        }
                     }
                  } catch (NotesException var19) {
                     if (this.debug != null) {
                        System.out.println("Mailing of report failed.");
                     }
                  }
               }
            }
         } catch (Exception var21) {
            ((Throwable)var21).printStackTrace();
         }
      }

   }

   Vector makeRowsFromCsv(String var1) {
      if (var1 == null) {
         return null;
      } else {
         Vector var2 = new Vector();
         StringTokenizer var3 = new StringTokenizer(var1, "\n");

         while(var3.hasMoreTokens()) {
            String var4 = var3.nextToken();
            StringTokenizer var5 = new StringTokenizer(var4, ",");
            Vector var6 = new Vector();

            while(var5.hasMoreTokens()) {
               String var7 = var5.nextToken();
               var6.addElement(var7);
            }

            var2.addElement(var6);
         }

         return var2;
      }
   }

   public String issueRequest(RepQuery var1, Document var2, String var3, String var4, String var5) throws Exception {
      Object var6 = null;

      try {
         int var7 = Integer.parseInt(var2.getNoteID(), 16);
         String var9 = this.NdoReport(var1.toString(), var7, var3, var4, var5);
         return var9;
      } catch (NumberFormatException var8) {
         throw new Exception();
      }
   }

   public void makeChart(RepQuery var1, Document var2, Vector var3, String var4, String var5) throws Exception {
      int var6 = var1.getReportId();
      RepDef var7 = RepDef.getDef(var6);
      Vector var8 = this.getColumnFrom(var7.getChartLabelCol(), var3);
      Vector var9 = this.getColumnFrom(var7.getChartValueCol(), var3);
      if (this.debug != null) {
         System.out.println("BEFORE: new RepChart");
      }

      RepChart var10 = new RepChart(var7, var8, var9);
      if (var10 != null && var10.isValid()) {
         if (this.debug != null) {
            System.out.println("AFTER : new RepChart");
         }

         String var11 = this.NgetTempPath();
         if (!var11.endsWith(File.separator)) {
            var11 = new String(var11 + File.separator);
         }

         if (this.debug != null) {
            System.out.println("BEFORE: writeAsTempGif");
         }

         String var12 = var10.writeAsTempGif(var11);
         if (this.debug != null) {
            System.out.println("AFTER : writeAsTempGif");
         }

         int var13 = Integer.parseInt(var2.getNoteID(), 16);
         if (this.debug != null) {
            System.out.println("BEFORE: NputChartInDoc");
         }

         if (this.debug != null) {
            System.out.println("File = " + var12);
         }

         this.NputChartInDoc(var12, var13, var4, var5);
         if (this.debug != null) {
            System.out.println("AFTER : NputChartInDoc");
         }

         var10.cleanUp();
         Object var14 = null;
      }
   }

   public Vector getColumnFrom(int var1, Vector var2) {
      Vector var3 = new Vector();

      String var5;
      for(Enumeration var4 = var2.elements(); var4.hasMoreElements(); var3.addElement(var5)) {
         var5 = "";
         Vector var6 = (Vector)var4.nextElement();
         if (var6 != null && var1 < var6.size()) {
            var5 = (String)var6.elementAt(var1);
         }
      }

      return var3;
   }

   static {
      String var0 = "wmsgtrc";
      String var1 = System.getProperty("os.name");
      String var2 = System.getProperty("os.arch");
      String var3 = "";
      String var4 = "";
      var1 = var1.toUpperCase();
      var2 = var2.toUpperCase();
      if (!var1.equals("WINDOWS NT") && !var1.equals("WINDOWS 95")) {
         if (var1.equals("WINDOWS")) {
            var3 = "_";
         } else if (var1.equals("OS/2")) {
            var3 = "i";
         } else if (var1.equals("AIX")) {
            var3 = "";
            var4 = "_r";
         } else if (var1.equals("SOLARIS")) {
            var3 = "";
         } else if (var1.equals("HPUX")) {
            var3 = "";
         } else if (var1.equals("OS/400")) {
            var3 = "lib";
         } else {
            var3 = "";
         }
      } else if (var2.equals("X86")) {
         var3 = "n";
      } else if (var2.equals("ALPHA")) {
         var3 = "a";
      }

      String var5 = var3 + var0 + var4;
      System.loadLibrary(var5);
   }
}
