package lotus.notes.apps.reports;

import java.util.Enumeration;
import java.util.Vector;

class RepDef {
   private static InternationalResources international_string = new InternationalResources("lotus/notes/apps/reports/ReportsResources");
   public static final String cAxisDelims = ":-";
   public static final int cAxisWidth = 2;
   public static final int cInvalidReportId = 0;
   public static final int cUserMsgCountReportId = 1;
   public static final int cUserMsgSizeReportId = 2;
   public static final int cOrigMsgCountReportId = 3;
   public static final int cOrigMsgSizeReportId = 4;
   public static final int cRecipMsgCountReportId = 5;
   public static final int cRecipMsgSizeReportId = 6;
   public static final int cNextHopMsgCountReportId = 7;
   public static final int cPrevHopMsgCountReportId = 8;
   public static final int cMsgSizeReportId = 10;
   public static final int cMsgSummaryReportId = 11;
   public static final int cMsgStatusReportId = 12;
   public static final String cTopNumStr;
   public static final String cUserMsgCountReportName;
   public static final String cUserMsgSizeReportName;
   public static final String cOrigMsgCountReportName;
   public static final String cOrigMsgSizeReportName;
   public static final String cRecipMsgCountReportName;
   public static final String cRecipMsgSizeReportName;
   public static final String cNextHopMsgCountReportName;
   public static final String cPrevHopMsgCountReportName;
   public static final String cMsgSizeReportName;
   public static final String cMsgSummaryReportName;
   public static final String cMsgStatusReportName;
   public static final int cMsgCountType = 1;
   public static final int cMsgSizeType = 2;
   public static final int cHopCountType = 3;
   public static final int cSentType = 4;
   public static final int cReceivedType = 5;
   public static final int cRelayedType = 6;
   public static final int cStatusType = 7;
   public static final int cStartTimeType = 8;
   public static final int cEndTimeType = 9;
   public static final int cUserType = 10;
   public static final int cOrigType = 11;
   public static final int cRecipType = 12;
   public static final int cMtaType = 13;
   public static final int cDoTypeBase = 5000;
   public static final int cDoUserServerType = 5000;
   public static final int cDoOrigServerType = 5001;
   public static final int cDoRecipServerType = 5002;
   public static final int cDoTotalType = 5003;
   public static final int cAlignLeft = 1;
   public static final int cAlignRight = 2;
   public static final int cAlignCenter = 3;
   public static final String cNL = "\n";
   public static final String cUser;
   public static final String cName;
   public static final String cOrig;
   public static final String cRecip;
   public static final String cServer;
   public static final String cCount;
   public static final String cSize;
   public static final String cMsg;
   public static final String cMsgs;
   public static final String cBytes;
   public static final String cTotal;
   public static final String cSent;
   public static final String cRelayed;
   public static final String cReceived;
   public static final String cHop;
   public static final String cPrev;
   public static final String cNext;
   public static final String cStart;
   public static final String cEnd;
   public static final String cTime;
   public static final String cDelivery;
   public static final String cStatus;
   private static Vector sRepDefs;
   private int mId;
   private String mDisplayName;
   private Vector mColDefs;
   private int mChartType;
   private boolean mUseLegend;
   private int mChartItemMax;
   private int mChartLabelCol;
   private int mChartValueCol;
   private boolean mUseAxis;
   private int mAxisWidth;
   private String mAxisDelims;

   public static Enumeration getDefs() {
      return sRepDefs.elements();
   }

   public static RepDef getDef(int var0) {
      Enumeration var1 = getDefs();

      while(var1.hasMoreElements()) {
         RepDef var2 = (RepDef)var1.nextElement();
         if (var2.getId() == var0) {
            return var2;
         }
      }

      return null;
   }

   public static RepColDef getColDef(int var0, int var1) {
      RepDef var2 = getDef(var0);
      if (var2 == null) {
         return null;
      } else {
         Vector var3 = var2.getColDefs();
         return var3.size() < var1 ? null : (RepColDef)var3.elementAt(var1);
      }
   }

   public static int getColType(int var0, int var1) {
      RepColDef var2 = getColDef(var0, var1);
      return var2 == null ? 0 : var2.getType();
   }

   public static String getColHeading(int var0, int var1) {
      RepColDef var2 = getColDef(var0, var1);
      return var2 == null ? null : var2.getHeading();
   }

   public static int getColAlign(int var0, int var1) {
      RepColDef var2 = getColDef(var0, var1);
      return var2 == null ? 0 : var2.getAlign();
   }

   public static int getNumCols(int var0) {
      RepDef var1 = getDef(var0);
      Vector var2 = var1.getColDefs();
      return var2.size();
   }

   public int getId() {
      return this.mId;
   }

   public String getDisplayName() {
      return this.mDisplayName;
   }

   public Vector getColDefs() {
      return this.mColDefs;
   }

   public int getChartType() {
      return this.mChartType;
   }

   public int getChartItemMax() {
      return this.mChartItemMax;
   }

   public int getChartLabelCol() {
      return this.mChartLabelCol;
   }

   public int getChartValueCol() {
      return this.mChartValueCol;
   }

   public boolean useLegend() {
      return this.mUseLegend;
   }

   public boolean useAxis() {
      return this.mUseAxis;
   }

   public int getAxisWidth() {
      return this.mAxisWidth;
   }

   public String getAxisDelims() {
      return this.mAxisDelims;
   }

   public RepDef(int var1, String var2) {
      this.mId = var1;
      this.mDisplayName = var2;
      this.mChartType = 0;
      this.mUseLegend = false;
      this.mUseAxis = false;
      this.mColDefs = new Vector();
   }

   public void setChart(int var1, int var2, boolean var3, int var4, int var5) {
      this.mChartType = var1;
      this.mChartItemMax = var2;
      this.mUseLegend = var3;
      this.mChartLabelCol = var4;
      this.mChartValueCol = var5;
   }

   public void setAxis(int var1, String var2) {
      this.mUseAxis = true;
      this.mAxisWidth = var1;
      this.mAxisDelims = var2;
   }

   public void add(RepColDef var1) {
      this.mColDefs.addElement(var1);
   }

   static {
      cTopNumStr = international_string.getString("keyword_top25");
      cUserMsgCountReportName = cTopNumStr + " " + international_string.getString("rpt_name_users_by_number");
      cUserMsgSizeReportName = cTopNumStr + " " + international_string.getString("rpt_name_users_by_size");
      cOrigMsgCountReportName = cTopNumStr + " " + international_string.getString("rpt_name_senders_by_number");
      cOrigMsgSizeReportName = cTopNumStr + " " + international_string.getString("rpt_name_senders_by_size");
      cRecipMsgCountReportName = cTopNumStr + " " + international_string.getString("rpt_name_receivers_by_number");
      cRecipMsgSizeReportName = cTopNumStr + " " + international_string.getString("rpt_name_receivers_by_size");
      cNextHopMsgCountReportName = cTopNumStr + " " + international_string.getString("rpt_name_next_hop");
      cPrevHopMsgCountReportName = cTopNumStr + " " + international_string.getString("rpt_name_previous_hop");
      cMsgSizeReportName = cTopNumStr + " " + international_string.getString("rpt_name_largest_messages");
      cMsgSummaryReportName = international_string.getString("rpt_name_message_volume");
      cMsgStatusReportName = international_string.getString("rpt_name_message_status");
      cUser = international_string.getString("keyword_user");
      cName = international_string.getString("keyword_name");
      cOrig = international_string.getString("keyword_sender");
      cRecip = international_string.getString("keyword_recipient");
      cServer = international_string.getString("keyword_server");
      cCount = international_string.getString("keyword_count");
      cSize = international_string.getString("keyword_size");
      cMsg = international_string.getString("keyword_message");
      cMsgs = international_string.getString("keyword_messages");
      cBytes = international_string.getString("keyword_bytes");
      cTotal = international_string.getString("keyword_total");
      cSent = international_string.getString("keyword_sent");
      cRelayed = international_string.getString("keyword_relayed");
      cReceived = international_string.getString("keyword_received");
      cHop = international_string.getString("keyword_hop");
      cPrev = international_string.getString("keyword_previous");
      cNext = international_string.getString("keyword_next");
      cStart = international_string.getString("keyword_start");
      cEnd = international_string.getString("keyword_end");
      cTime = international_string.getString("keyword_time");
      cDelivery = international_string.getString("keyword_delivery");
      cStatus = international_string.getString("keyword_status");
      sRepDefs = new Vector();
      RepDef var0 = new RepDef(1, cUserMsgCountReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(10, cUser + "\n" + cName, 1));
      var0.add(new RepColDef(5003, cTotal + "\n" + cMsgs, 3));
      var0.add(new RepColDef(4, cMsgs + "\n" + cSent, 3));
      var0.add(new RepColDef(6, cMsgs + "\n" + cRelayed, 3));
      var0.add(new RepColDef(5, cMsgs + "\n" + cReceived, 3));
      var0.add(new RepColDef(5000, cUser + "\n" + cServer, 1));
      sRepDefs.addElement(var0);
      var0 = new RepDef(2, cUserMsgSizeReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(10, cUser + "\n" + cName, 1));
      var0.add(new RepColDef(5003, cTotal + "\n" + cBytes, 3));
      var0.add(new RepColDef(4, cBytes + "\n" + cSent, 3));
      var0.add(new RepColDef(6, cBytes + "\n" + cRelayed, 3));
      var0.add(new RepColDef(5, cBytes + "\n" + cReceived, 3));
      var0.add(new RepColDef(5000, cUser + "\n" + cServer, 1));
      sRepDefs.addElement(var0);
      var0 = new RepDef(3, cOrigMsgCountReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(11, cOrig + "\n" + cName, 1));
      var0.add(new RepColDef(1, cMsgs + "\n" + cSent, 3));
      var0.add(new RepColDef(13, cNext + "\n" + cHop + " " + cName, 3));
      var0.add(new RepColDef(3, cHop + "\n" + cMsgs, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(4, cOrigMsgSizeReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(11, cOrig + "\n" + cName, 1));
      var0.add(new RepColDef(2, cBytes + "\n" + cSent, 3));
      var0.add(new RepColDef(13, cPrev + "\n" + cHop + " " + cName, 3));
      var0.add(new RepColDef(3, cHop + "\n" + cBytes, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(5, cRecipMsgCountReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(12, cRecip + "\n" + cName, 1));
      var0.add(new RepColDef(1, cMsgs + "\n" + cReceived, 3));
      var0.add(new RepColDef(13, cPrev + "\n" + cHop + " " + cName, 3));
      var0.add(new RepColDef(3, cHop + "\n" + cMsgs, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(6, cRecipMsgSizeReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(12, cRecip + "\n" + cName, 1));
      var0.add(new RepColDef(2, cBytes + "\n" + cReceived, 3));
      var0.add(new RepColDef(13, cPrev + "\n" + cHop + " " + cName, 3));
      var0.add(new RepColDef(3, cHop + "\n" + cBytes, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(7, cNextHopMsgCountReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(13, cNext + "\n" + cHop + " " + cName, 1));
      var0.add(new RepColDef(1, cMsg + "\n" + cCount, 3));
      var0.add(new RepColDef(2, cMsg + "\n" + cBytes, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(8, cPrevHopMsgCountReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(13, cPrev + "\n" + cHop + " " + cName, 1));
      var0.add(new RepColDef(1, cMsg + "\n" + cCount, 3));
      var0.add(new RepColDef(2, cMsg + "\n" + cBytes, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(10, cMsgSizeReportName);
      var0.setChart(2, 10, true, 0, 4);
      var0.add(new RepColDef(11, cOrig + "\n" + cName, 1));
      var0.add(new RepColDef(5001, cOrig + "\n" + cServer, 3));
      var0.add(new RepColDef(12, cRecip + "\n" + cName, 1));
      var0.add(new RepColDef(5002, cRecip + "\n" + cServer, 1));
      var0.add(new RepColDef(2, cMsg + "\n" + cSize, 3));
      sRepDefs.addElement(var0);
      var0 = new RepDef(11, cMsgSummaryReportName);
      var0.setChart(2, -1, false, 0, 2);
      var0.setAxis(2, ":-");
      var0.add(new RepColDef(8, cStart + "\n" + cTime, 3));
      var0.add(new RepColDef(9, cEnd + "\n" + cTime, 3));
      var0.add(new RepColDef(1, cMsg + "\n" + cCount, 2));
      var0.add(new RepColDef(2, cMsg + "\n" + cBytes, 2));
      sRepDefs.addElement(var0);
      var0 = new RepDef(12, cMsgStatusReportName);
      var0.setChart(2, 10, true, 0, 1);
      var0.add(new RepColDef(7, cDelivery + "\n" + cStatus, 3));
      var0.add(new RepColDef(1, cMsg + "\n" + cCount, 2));
      sRepDefs.addElement(var0);
   }
}
