package lotus.notes.apps.wmsgtrc;

import java.io.PrintWriter;
import lotus.domino.DateTime;
import lotus.domino.Document;
import lotus.domino.NotesException;
import lotus.domino.Session;

public class MsgTrackResponseEntry {
   private DispositionStatus dispositionStatus;
   private String inboundOriginator;
   private String outboundOriginator;
   private String inboundRecipient;
   private String outboundRecipient;
   private String mta;
   private String nextHopMta;
   private String previousHopMta;
   private String msgPriority;
   private String msgID;
   private String inboundMsgID;
   private String outboundMsgID;
   private String subject;
   private String supplementalInfo;
   private String nonDeliveryReason;
   private DateTime dispositionTime;
   private DateTime msgArrivalTime;
   private int msgType;
   private int msgSize;
   private int mailBoxStatus;
   private static final int MAIL_MESSAGEFLAG_BASE = 0;
   public static final int MAIL_MESSAGEFLAG_UNKNOWN = 1;
   public static final int MAIL_MESSAGEFLAG_MEMO = 2;
   public static final int MAIL_MESSAGEFLAG_DELIVERYREPORT = 4;
   public static final int MAIL_MESSAGEFLAG_NONDELIVERYREPORT = 8;
   public static final int MAIL_MESSAGEFLAG_RETURNRECEIPT = 16;
   public static final int MAIL_MESSAGEFLAG_PHONEMESSAGE = 32;
   public static final int MAIL_MESSAGEFLAG_TRACEREPORT = 64;
   public static final int MAIL_MESSAGEFLAG_NOTICE = 128;
   public static final int MAIL_MESSAGEFLAGS_ALL = 255;
   public static final int MAILBOX_STATUSFLAG_UNKNOWN = 0;
   public static final int MAILBOX_STATUSFLAG_UNREAD = 1;
   public static final int MAILBOX_STATUSFLAG_READ = 2;
   public static final int MAILBOX_STATUSFLAG_DELETED = 3;

   public static String mailBoxStatusStringValue(int var0) {
      InternationalResources var1 = new InternationalResources("lotus.notes.apps.wmsgtrc.WebMsgTrackResources");
      switch (var0) {
         case 0:
            return var1.getString("unknown");
         case 1:
            return var1.getString("unread");
         case 2:
            return var1.getString("read");
         case 3:
            return var1.getString("deleted");
         default:
            return null;
      }
   }

   MsgTrackResponseEntry(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, String var10, String var11, String var12, String var13, String var14, int var15, int var16, DispositionStatus var17, DateTime var18, DateTime var19) {
      this.inboundOriginator = var1;
      this.inboundRecipient = var2;
      this.outboundOriginator = var3;
      this.outboundRecipient = var4;
      this.dispositionStatus = var17;
      this.dispositionTime = var18;
      this.msgArrivalTime = var19;
      this.mta = var5;
      this.nextHopMta = var6;
      this.previousHopMta = var7;
      this.msgSize = var16;
      this.msgPriority = var8;
      this.msgID = var9;
      this.inboundMsgID = var10;
      this.outboundMsgID = var11;
      this.subject = var12;
      this.supplementalInfo = var13;
      this.msgType = var15;
      this.nonDeliveryReason = var14;
   }

   MsgTrackResponseEntry() {
   }

   public void setInboundOriginator(String var1) {
      this.inboundOriginator = var1;
   }

   public void setInboundRecipient(String var1) {
      this.inboundRecipient = var1;
   }

   public void setOutboundOriginator(String var1) {
      this.outboundOriginator = var1;
   }

   public void setOutboundRecipient(String var1) {
      this.outboundRecipient = var1;
   }

   public void setMta(String var1) {
      this.mta = var1;
   }

   public void setNextHopMta(String var1) {
      this.nextHopMta = var1;
   }

   public void setPrevHopMta(String var1) {
      this.previousHopMta = var1;
   }

   public void setMsgPriority(String var1) {
      this.msgPriority = var1;
   }

   public void setSupplementalInfo(String var1) {
      this.supplementalInfo = var1;
   }

   public void setMsgID(String var1) {
      this.msgID = var1;
   }

   public void setInboundMsgID(String var1) {
      this.inboundMsgID = var1;
   }

   public void setOutboundMsgID(String var1) {
      this.outboundMsgID = var1;
   }

   public void setSubject(String var1) {
      this.subject = var1;
   }

   public void setMsgType(int var1) {
      this.msgType = var1;
   }

   public void setMsgSize(int var1) {
      this.msgSize = var1;
   }

   public void setMailBoxStatus(int var1) {
      this.mailBoxStatus = var1;
   }

   public void setDispositionTime(DateTime var1) {
      this.dispositionTime = var1;
   }

   public void setDispositionTime(String var1, Session var2, long var3, long var5) {
      try {
         this.dispositionTime = var2.createDateTime("");
         this.dispositionTime.setLocalTime(var1);
         boolean var7 = false;
         if (var5 != 0L) {
            var7 = true;
         }

         Long var8 = new Long(var3);
         this.ConvertToTimeZone(var8.intValue(), var7, this.dispositionTime);
      } catch (NotesException var9) {
         ((Throwable)var9).printStackTrace();
         System.out.println("Notes Exception in convert time " + var9);
      }
   }

   public void setMsgArrivalTime(String var1, Session var2, long var3, long var5) {
      try {
         this.msgArrivalTime = var2.createDateTime("");
         this.msgArrivalTime.setLocalTime(var1);
         boolean var7 = false;
         if (var5 != 0L) {
            var7 = true;
         }

         Long var8 = new Long(var3);
         this.ConvertToTimeZone(var8.intValue(), var7, this.msgArrivalTime);
      } catch (NotesException var9) {
         ((Throwable)var9).printStackTrace();
      }
   }

   public void setMsgArrivalTime(DateTime var1) {
      this.msgArrivalTime = var1;
   }

   public void ConvertToTimeZone(int var1, boolean var2, DateTime var3) {
      byte var4 = 0;
      int var5 = 0;
      int var6 = 0;

      try {
         new String("");
         String var7 = String.valueOf(var1);
         if (var7.charAt(0) == '-') {
            var4 = 1;
         }

         if (var7.length() > var4 + 2) {
            String var8 = var7.substring(0, var4 + 2);
            var5 = Integer.parseInt(var8);
            if (var4 == 1) {
               var6 = Integer.parseInt("-" + var7.substring(var4 + 2, var7.length()));
            } else {
               var6 = Integer.parseInt(var7.substring(var4 + 2, var7.length()));
            }

            var3.convertToZone(var6, var2);
            var3.adjustMinute(var5, true);
         } else {
            var3.convertToZone(var1, var2);
         }
      } catch (NotesException var9) {
         ((Throwable)var9).printStackTrace();
         System.out.println("Notes Exception in convert to zone" + var9);
      }
   }

   public void setDispositionStatus(DispositionStatus var1) {
      this.dispositionStatus = var1;
   }

   public void setDispositionStatus(int var1) {
      this.dispositionStatus = new DispositionStatus(var1);
   }

   public void setNonDeliveryReason(String var1) {
      this.nonDeliveryReason = var1;
   }

   public String getInboundOriginator() {
      return this.inboundOriginator;
   }

   public String getInboundRecipient() {
      return this.inboundRecipient;
   }

   public String getOutboundOriginator() {
      return this.outboundOriginator;
   }

   public String getOutboundRecipient() {
      return this.outboundRecipient;
   }

   public String getMta() {
      return this.mta;
   }

   public String getNextHopMta() {
      return this.nextHopMta;
   }

   public String getPreviousHopMta() {
      return this.previousHopMta;
   }

   public String getMsgPriority() {
      return this.msgPriority;
   }

   public String getSupplementalInfo() {
      return this.supplementalInfo;
   }

   public String getMsgID() {
      return this.msgID;
   }

   public String getInboundMsgID() {
      return this.inboundMsgID;
   }

   public String getOutboundMsgID() {
      return this.outboundMsgID;
   }

   public String getSubject() {
      return this.subject;
   }

   public int getMsgType() {
      return this.msgType;
   }

   public String getMsgTypeString() {
      InternationalResources var1 = new InternationalResources("lotus.notes.apps.wmsgtrc.WebMsgTrackResources");
      new String(var1.getString("unknown"));
      String var2;
      switch (this.msgType) {
         case 1:
         default:
            var2 = var1.getString("unknown");
            break;
         case 2:
            var2 = var1.getString("memo");
            break;
         case 4:
            var2 = var1.getString("delivery_report");
            break;
         case 8:
            var2 = var1.getString("non_delivery_report");
            break;
         case 16:
            var2 = var1.getString("return_receipt");
            break;
         case 32:
            var2 = var1.getString("phone_message");
            break;
         case 64:
            var2 = var1.getString("trace_report");
            break;
         case 128:
            var2 = var1.getString("notice");
      }

      return var2;
   }

   public int getMailBoxStatus() {
      return this.mailBoxStatus;
   }

   public String getMailBoxStatusString() {
      InternationalResources var1 = new InternationalResources("lotus.notes.apps.wmsgtrc.WebMsgTrackResources");
      new String(var1.getString("unknown"));
      String var2;
      switch (this.mailBoxStatus) {
         case 0:
            var2 = var1.getString("unknown");
            break;
         case 1:
            var2 = var1.getString("unread");
            break;
         case 2:
            var2 = var1.getString("read");
            break;
         case 3:
            var2 = var1.getString("deleted");
            break;
         default:
            var2 = null;
      }

      return var2;
   }

   public int getMsgSize() {
      return this.msgSize;
   }

   public DateTime getDispositionTime() {
      try {
         return this.dispositionTime;
      } catch (Exception var2) {
         System.out.println("Exception in get DispositionTime " + var2);
         return null;
      }
   }

   public DateTime getMsgArrivalTime() {
      return this.msgArrivalTime;
   }

   public DispositionStatus getDispositionStatus() {
      return this.dispositionStatus;
   }

   public String getDispositionStatusString() {
      return DispositionStatus.stringValue(this.dispositionStatus.getIntValue());
   }

   public String getNonDeliveryReason() {
      return this.nonDeliveryReason;
   }

   public void dump(PrintWriter var1, Document var2) {
      try {
         var1.println("MtResponse Entry Values");
         var1.println("QUERY From Document: " + var2.getUniversalID());
         if (this.getInboundOriginator() == null) {
            var1.println("null");
         } else {
            var1.println(" InboundOriginator = " + this.getInboundOriginator());
         }

         if (this.getInboundRecipient() == null) {
            var1.println("null");
         } else {
            var1.println(" InboundRecipient = " + this.getInboundRecipient());
         }

         if (this.getOutboundOriginator() == null) {
            var1.println("null");
         } else {
            var1.println(" OutboundOriginator = " + this.getOutboundOriginator());
         }

         if (this.getOutboundRecipient() == null) {
            var1.println("null");
         } else {
            var1.println("  OutboundRecipient = " + this.getOutboundRecipient());
         }

         if (this.getDispositionStatus() == null) {
            var1.println("null");
         } else {
            var1.println(" DispositionStatus = " + this.getDispositionStatus());
         }

         if (this.getMta() == null) {
            var1.println("null");
         } else {
            var1.println(" Mta = " + this.getMta());
         }

         if (this.getNextHopMta() == null) {
            var1.println("null");
         } else {
            var1.println(" NextHopMta = " + this.getNextHopMta());
         }

         if (this.getPreviousHopMta() == null) {
            var1.println("null");
         } else {
            var1.println(" PrevHopMta = " + this.getPreviousHopMta());
         }

         if (this.getSubject() == null) {
            var1.println("null");
         } else {
            var1.println(" Subject = " + this.getSubject());
         }

         if (this.getMsgID() == null) {
            var1.println("null");
         } else {
            var1.println(" MsgID = " + this.getMsgID());
         }

         if (this.getInboundMsgID() == null) {
            var1.println("null");
         } else {
            var1.println(" InboundMsgID = " + this.getInboundMsgID());
         }

         if (this.getOutboundMsgID() == null) {
            var1.println("null");
         } else {
            var1.println(" OutboundMsgID = " + this.getOutboundMsgID());
         }

         if (this.getMsgType() == 0) {
            var1.println("null");
         } else {
            var1.println(" MsgType = " + this.getMsgType());
         }

         if (this.getMsgSize() == 0) {
            var1.println("null");
         } else {
            var1.println(" MsgSize = " + this.getMsgSize());
         }

         if (this.getMsgArrivalTime() == null) {
            var1.println("null");
         } else {
            var1.println(" MsgArrivalTime = " + this.getMsgArrivalTime().getLocalTime());
         }

         if (this.getDispositionTime() == null) {
            var1.println("null");
         } else {
            var1.println(" DispositionTime = " + this.getDispositionTime().getLocalTime());
         }

         if (this.getSupplementalInfo() == null) {
            var1.println("null");
         } else {
            var1.println(" SupplementalInfo = " + this.getSupplementalInfo());
         }

         if (this.getMsgPriority() == null) {
            var1.println("null");
         } else {
            var1.println(" MsgPriority = " + this.getMsgPriority());
         }

         if (this.getNonDeliveryReason() == null) {
            var1.println("null");
         } else {
            var1.println(" NonDeliveryReason = " + this.getNonDeliveryReason());
         }

         if (this.getMailBoxStatusString() == null) {
            var1.println("MailBoxStatus = null");
         } else {
            var1.println("MailBoxStatus = " + this.getMailBoxStatusString());
         }

         var1.println("");
      } catch (Exception var4) {
         ((Throwable)var4).printStackTrace();
      }
   }
}
