package lotus.notes.apps.wmsgtrc;

import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Vector;
import lotus.domino.ACL;
import lotus.domino.ACLEntry;
import lotus.domino.AgentBase;
import lotus.domino.AgentContext;
import lotus.domino.Database;
import lotus.domino.Document;
import lotus.domino.Item;
import lotus.domino.Name;
import lotus.domino.NotesException;
import lotus.domino.Session;

public class WebMsgTrack extends AgentBase {
   public boolean WMSGTRACK_DEBUG = false;
   private static final int MAXROWS = 25;
   private InternationalResources intlStr;
   public static final int JNI_MSGTRACK_SUCCESS = 0;
   public static final int JNI_MSGTRACK_UNDERQUALIFIED = 1;
   public static final int JNI_MSGTRACK_NOTFOUND = 2;
   public static final int JNI_MSGTRACK_DUPLICATE = 3;
   public static final int JNI_MSGTRACK_FAILED = 4;
   public static final int JNI_MSGTRACK_UNABLE_TO_FIND_SERVER = 5;
   private static final String sSubjectRole = "[ServerAdmin]";
   private boolean bAllFieldsEnabled = false;
   // $FF: renamed from: pw java.io.PrintWriter
   private PrintWriter field_0;
   private Document doc;
   private Document ndoc;
   private Session session;
   private String mta;

   public native int NwTrackMessage(MsgTrackRequestEntry var1, Vector var2, Session var3);

   public void NotesMain() {
      try {
         this.session = ((AgentBase)this).getSession();
         AgentContext var1 = this.session.getAgentContext();
         this.WMSGTRACK_DEBUG = this.checkDebug(this.session);
         this.doc = var1.getDocumentContext();
         this.intlStr = new InternationalResources("lotus.notes.apps.wmsgtrc.WebMsgTrackResources");
         this.bAllFieldsEnabled = this.isSubjectEnabled(this.session, "[ServerAdmin]");
         this.field_0 = ((AgentBase)this).getAgentOutput();
         MsgTrackRequestEntry var2 = new MsgTrackRequestEntry(this.doc, this.session);
         if (this.WMSGTRACK_DEBUG) {
            var2.dump(this.field_0, this.doc);
         }

         Vector var3 = new Vector();
         int var4 = this.NwTrackMessage(var2, var3, this.session);
         ResultsOut var5 = new ResultsOut(this.field_0, this.doc);
         var5.setDebugFlag(this.WMSGTRACK_DEBUG);
         new String("");
         switch (var4) {
            case 0:
               if (this.WMSGTRACK_DEBUG) {
                  System.out.println("Summary");
                  System.out.println("Number of hops =: " + var3.size());
               }

               Enumeration var13 = var3.elements();

               while(var13.hasMoreElements()) {
                  MsgTrackResponseEntry var14 = (MsgTrackResponseEntry)var13.nextElement();
                  if (this.WMSGTRACK_DEBUG) {
                     this.dumprsp(var14);
                  }
               }

               var5.SummaryOut(var2, var3, this.doc, this.field_0, this.bAllFieldsEnabled);
               return;
            case 1:
               if (this.WMSGTRACK_DEBUG) {
                  System.out.println("Underspec");
                  System.out.println("Number of responses =: " + var3.size());
                  Enumeration var7 = var3.elements();

                  while(var7.hasMoreElements()) {
                     MsgTrackResponseEntry var8 = (MsgTrackResponseEntry)var7.nextElement();
                     this.dumprsp(var8);
                  }
               }

               var5.UnderspecifiedOut(var2, var3, this.bAllFieldsEnabled);
               return;
            case 2:
               String var11 = this.intlStr.getString("err_no_messages");
               var5.ErrorOut(var2, var11);
               return;
            case 3:
               String var10 = this.intlStr.getString("err_duplicate") + " " + var2.getMta();
               var5.ErrorOut(var2, var10);
               return;
            case 4:
            default:
               String var12 = this.intlStr.getString("err_tracking_failed");
               var5.ErrorOut(var2, var12);
               return;
            case 5:
               String var6 = this.intlStr.getString("err_servernotfound") + " " + var2.getMta();
               var5.ErrorOut(var2, var6);
         }
      } catch (Exception var9) {
         ((Throwable)var9).printStackTrace();
      }
   }

   private void MainQueryOut(Document var1) {
      System.out.println("The values of all the fields in the form");

      try {
         Vector var2 = var1.getItems();
         System.out.println("Found vector with " + var2.size() + " elements<BR>");

         for(int var3 = 0; var3 < var2.size(); ++var3) {
            Item var4 = (Item)var2.elementAt(var3);
            System.out.print("Item " + var3 + " :  ");
            if (var4 == null) {
               System.out.print("NULL");
            } else {
               System.out.print(var4.getName() + " / " + var4.getText());
            }

            System.out.println("<BR>");
         }

      } catch (NotesException var5) {
         ((Throwable)var5).printStackTrace();
      }
   }

   public boolean IsBrowserSupported(Document var1) {
      boolean var2 = true;

      try {
         String var3 = var1.getItemValueString("HTTP_User_Agent");
         if (var3.indexOf("MSIE 2") != -1) {
            var2 = false;
         } else if (var3.indexOf("Windows 3.1") != -1) {
            var2 = false;
         } else if (var3.indexOf("Win16") != -1) {
            var2 = false;
         } else if (var3.indexOf("MSIE 3") != -1 && var3.indexOf("MAC") != -1) {
            var2 = false;
         } else {
            var2 = true;
         }
      } catch (Exception var4) {
         ((Throwable)var4).printStackTrace();
         var2 = false;
      }

      return var2;
   }

   public boolean isLowEndBrowser(Document var1) {
      try {
         String var2 = var1.getItemValueString("HTTP_User_Agent");
         return var2.indexOf("OS/2") != -1 || var2.indexOf("Windows 3.1") != -1 || var2.indexOf("Win16") != -1;
      } catch (Exception var3) {
         System.out.println("Notes Exception " + var3);
         return false;
      }
   }

   private String getPath(Document var1, AgentContext var2) {
      String var3 = "";

      try {
         var3 = var1.getItemValueString("Server_Name") + "/" + var2.getCurrentDatabase();
      } catch (NotesException var5) {
         System.out.println("Notes Exception" + var5);
      }

      return var3;
   }

   private boolean isSubjectEnabled(Session var1, String var2) {
      boolean var3 = false;
      String var4 = new String("");

      try {
         AgentContext var5 = var1.getAgentContext();
         Database var6 = var5.getCurrentDatabase();
         ACL var7 = var6.getACL();
         Vector var8 = var7.getRoles();
         if (var8 == null || !var8.contains(var2)) {
            return false;
         }

         Name var9 = var1.getUserNameObject();
         if (var9 == null) {
            System.out.println(this.intlStr.getString("err_name"));
            return false;
         }

         if (var9.isHierarchical()) {
            var4 = var1.getCommonUserName();
         }

         if (var1.isOnServer()) {
            var4 = var5.getEffectiveUserName();
         }

         if (var4 == null) {
            System.out.println(this.intlStr.getString("err_name"));
            return false;
         }

         if (this.WMSGTRACK_DEBUG) {
            System.out.println("Username = " + var4);
         }

         Name var10 = this.session.createName(var4);
         if (var10 == null) {
            return false;
         }

         ACLEntry var11 = var7.getEntry(var10.getAbbreviated());
         var10.recycle();
         if (var11 == null) {
            var11 = var7.getEntry("-Default-");
         }

         var3 = var11.isRoleEnabled(var2);
      } catch (NotesException var12) {
         ((Throwable)var12).printStackTrace();
         System.out.println("Notes Exception e  " + this.intlStr.getString("err_name"));
         var3 = false;
      }

      return var3;
   }

   public boolean getDebugFlag() {
      return this.WMSGTRACK_DEBUG;
   }

   private boolean checkDebug(Session var1) {
      boolean var2 = false;

      try {
         String var3 = var1.getEnvironmentString("debug_wmsgtrc", true);
         if (var3 != null && var3.compareTo("1") == 0) {
            var2 = true;
         }
      } catch (NotesException var4) {
      }

      return var2;
   }

   public void dumprsp(MsgTrackResponseEntry var1) {
      try {
         System.out.println("MtResponse Entry Values");
         System.out.println("QUERY From Document: " + this.doc.getUniversalID());
         if (var1.getInboundOriginator() == null) {
            System.out.println("null");
         } else {
            System.out.println(" InboundOriginator = " + var1.getInboundOriginator());
         }

         if (var1.getInboundRecipient() == null) {
            System.out.println("null");
         } else {
            System.out.println(" InboundRecipient = " + var1.getInboundRecipient());
         }

         if (var1.getOutboundOriginator() == null) {
            System.out.println("null");
         } else {
            System.out.println(" OutboundOriginator = " + var1.getOutboundOriginator());
         }

         if (var1.getOutboundRecipient() == null) {
            System.out.println("null");
         } else {
            System.out.println("  OutboundRecipient = " + var1.getOutboundRecipient());
         }

         if (var1.getDispositionStatusString() == null) {
            System.out.println("null");
         } else {
            System.out.println(" DispositionStatus = " + var1.getDispositionStatusString());
         }

         if (var1.getMta() == null) {
            System.out.println("null");
         } else {
            System.out.println(" Mta = " + var1.getMta());
         }

         if (var1.getNextHopMta() == null) {
            System.out.println("null");
         } else {
            System.out.println(" NextHopMta = " + var1.getNextHopMta());
         }

         if (var1.getPreviousHopMta() == null) {
            System.out.println("null");
         } else {
            System.out.println(" PrevHopMta = " + var1.getPreviousHopMta());
         }

         if (var1.getSubject() == null) {
            System.out.println("null");
         } else {
            System.out.println(" Subject = " + var1.getSubject());
         }

         if (var1.getMsgID() == null) {
            System.out.println("null");
         } else {
            System.out.println(" MsgID = " + var1.getMsgID());
         }

         if (var1.getInboundMsgID() == null) {
            System.out.println("null");
         } else {
            System.out.println(" InboundMsgID = " + var1.getInboundMsgID());
         }

         if (var1.getOutboundMsgID() == null) {
            System.out.println("null");
         } else {
            System.out.println(" OutboundMsgID = " + var1.getOutboundMsgID());
         }

         if (var1.getMsgType() < 0) {
            System.out.println("null");
         } else {
            System.out.println(" MsgType = " + var1.getMsgTypeString());
         }

         if (var1.getMsgSize() <= 0) {
            System.out.println("null");
         } else {
            System.out.println(" MsgSize = " + var1.getMsgSize());
         }

         if (var1.getMsgArrivalTime().getLocalTime() == null) {
            System.out.println("null");
         } else {
            System.out.println(" MsgArrivalTime = " + var1.getMsgArrivalTime().getLocalTime());
         }

         if (var1.getDispositionTime().getLocalTime() == null) {
            System.out.println("null");
         } else {
            System.out.println(" DispositionTime = " + var1.getDispositionTime().getLocalTime());
         }

         if (var1.getSupplementalInfo() == null) {
            System.out.println("null");
         } else {
            System.out.println(" SupplementalInfo = " + var1.getSupplementalInfo());
         }

         if (var1.getMsgPriority() == null) {
            System.out.println("null");
         } else {
            System.out.println(" MsgPriority = " + var1.getMsgPriority());
         }

         if (var1.getNonDeliveryReason() == null) {
            System.out.println("Non Delivery Reason = null");
         } else {
            System.out.println(" NonDeliveryReason = " + var1.getNonDeliveryReason());
         }

         System.out.println("");
      } catch (Exception var3) {
         ((Throwable)var3).printStackTrace();
      }
   }

   static {
      try {
         String var0 = "wmsgtrc";
         System.out.print("Loading...");
         String var1 = System.getProperty("os.name");
         String var2 = System.getProperty("os.arch");
         String var3 = "";
         String var4 = "";
         var1 = var1.toUpperCase();
         var2 = var2.toUpperCase();
         if (!var1.equals("WINDOWS NT") && !var1.equals("WINDOWS 95")) {
            if (var1.equals("WINDOWS")) {
               var3 = "_";
            } else if (var1.equals("OS/2")) {
               var3 = "i";
            } else if (var1.equals("AIX")) {
               var3 = "";
               var4 = "_r";
            } else if (var1.equals("SOLARIS")) {
               var3 = "";
            } else if (var1.equals("HPUX")) {
               var3 = "";
            } else if (var1.equals("OS/400")) {
               var3 = "lib";
            } else {
               var3 = "";
            }
         } else if (var2.equals("X86")) {
            var3 = "n";
         } else if (var2.equals("ALPHA")) {
            var3 = "a";
         }

         String var5 = var3 + var0 + var4;
         System.loadLibrary(var5);
         System.out.println(var5 + ".");
      } catch (Exception var6) {
         System.out.println("Encountered error loading library: + aDLLname");
         System.out.println(((Throwable)var6).getMessage());
      }
   }
}
