package lotus.notes.internal;

import java.util.Enumeration;

class InfoPaneMemberItem implements InfoPaneItem {
   protected String name;
   protected String longName;

   InfoPaneMemberItem() {
   }

   InfoPaneMemberItem(String var1) {
      this(StripModifiers(StripPack(var1)), var1);
   }

   InfoPaneMemberItem(String var1, String var2) {
      this.name = StripModifiers(StripPack(var1));
      this.longName = var2;
   }

   static String StripModifiers(String var0) {
      return StripModifier(StripModifier(var0, "public"), "interface");
   }

   static String StripModifier(String var0, String var1) {
      return var0.startsWith(var1) ? var0.substring(var1.length() + 1) : var0;
   }

   static String StripPack(String var0) {
      return StripPack(StripPack(var0, "java.lang"), "lotus.domino");
   }

   static String StripPack(String var0, String var1) {
      if (var0.startsWith(var1)) {
         String var2 = var0.substring(var1.length() + 1);
         if (var2.indexOf(46) < 0) {
            return var2;
         }
      }

      return var0;
   }

   public boolean HasSubCategory() {
      return false;
   }

   public Enumeration GetEnumeration() {
      return null;
   }

   public String GetName() {
      return this.name;
   }

   public String GetLongName() {
      return this.longName;
   }

   public boolean HasLongName() {
      return this.longName != null && this.name != null && this.longName.length() > this.name.length();
   }

   public boolean CanPaste() {
      return true;
   }

   public void Print(String var1, boolean var2) {
      if (var2 && this.HasLongName() && this.CanPaste()) {
         System.out.println(var1 + this.GetLongName());
      } else {
         System.out.println(var1 + this.GetName());
      }

      if (this.HasSubCategory()) {
         Enumeration var3 = this.GetEnumeration();

         while(var3.hasMoreElements()) {
            ((InfoPaneItem)var3.nextElement()).Print(var1 + "  ", var2);
         }
      }

   }
}
