package lotus.notes.internal;

import java.util.Enumeration;
import lotus.notes.JavaString;

class InfoPanePackageSubItem implements InfoPaneItem {
   private InfoPaneVector vector;
   private String name;

   InfoPanePackageSubItem(String var1) {
      this.name = var1;
      this.vector = new InfoPaneVector();
   }

   InfoPaneClassItem FindClass(String var1) {
      return (InfoPaneClassItem)this.vector.Find(var1);
   }

   InfoPaneClassItem AddClass(String var1, String var2) throws InfoPaneException {
      return (InfoPaneClassItem)this.vector.Insert(new InfoPaneClassItem(var1, var2));
   }

   public boolean HasSubCategory() {
      return this.vector != null && this.vector.size() > 0;
   }

   public Enumeration GetEnumeration() {
      return this.vector == null ? null : this.vector.elements();
   }

   public String GetName() {
      return JavaString.resource.getString("InfoPane_" + this.name);
   }

   public String GetLongName() {
      return this.GetName();
   }

   public boolean HasLongName() {
      return false;
   }

   public boolean CanPaste() {
      return false;
   }

   public void Print(String var1, boolean var2) {
      if (var2 && this.HasLongName() && this.CanPaste()) {
         System.out.println(var1 + this.GetLongName());
      } else {
         System.out.println(var1 + this.GetName());
      }

      if (this.HasSubCategory()) {
         Enumeration var3 = this.GetEnumeration();

         while(var3.hasMoreElements()) {
            ((InfoPaneItem)var3.nextElement()).Print(var1 + "  ", var2);
         }
      }

   }
}
