package lotus.notes.internal;

import java.util.Enumeration;
import lotus.notes.JavaString;

class InfoPaneTopItem implements InfoPaneItem {
   private InfoPaneVector vector;
   String name;

   InfoPaneTopItem(String var1) {
      this.name = var1;
      this.vector = new InfoPaneVector();
   }

   InfoPanePackageItem FindPackage(String var1) {
      return (InfoPanePackageItem)this.vector.Find(var1);
   }

   InfoPanePackageItem AddPackage(String var1) throws InfoPaneException {
      return this.AddPackage(new InfoPanePackageItem(var1));
   }

   InfoPanePackageItem AddPackage(InfoPanePackageItem var1) throws InfoPaneException {
      return (InfoPanePackageItem)this.vector.Insert(var1);
   }

   public boolean HasSubCategory() {
      return this.vector != null && this.vector.size() > 0;
   }

   public Enumeration GetEnumeration() {
      return this.vector == null ? null : this.vector.elements();
   }

   public String GetName() {
      return !this.name.equals("Core") && !this.name.equals("Notes") ? JavaString.getFormattedString("InfoPane_Java", this.name) : JavaString.resource.getString("InfoPane_" + this.name + "_Java");
   }

   public String GetLongName() {
      return this.GetName();
   }

   public boolean HasLongName() {
      return false;
   }

   public boolean CanPaste() {
      return false;
   }

   public void Print(String var1, boolean var2) {
      if (var2 && this.HasLongName() && this.CanPaste()) {
         System.out.println(var1 + this.GetLongName());
      } else {
         System.out.println(var1 + this.GetName());
      }

      if (this.HasSubCategory()) {
         Enumeration var3 = this.GetEnumeration();

         while(var3.hasMoreElements()) {
            ((InfoPaneItem)var3.nextElement()).Print(var1 + "  ", var2);
         }
      }

   }
}
