package lotus.notes.internal;

import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Enumeration;
import java.util.Vector;

class InfoPaneVector extends Vector {
   InfoPaneItem Find(String var1) {
      Enumeration var2 = ((Vector)this).elements();

      while(var2.hasMoreElements()) {
         InfoPaneItem var3 = (InfoPaneItem)var2.nextElement();
         int var4 = var1.compareTo(var3.GetName());
         if (var4 == 0) {
            return var3;
         }

         if (var4 < 0) {
            return null;
         }
      }

      return null;
   }

   InfoPaneItem Insert(InfoPaneItem var1) throws InfoPaneException {
      return this.Insert(var1, false);
   }

   InfoPaneItem Insert(InfoPaneItem var1, boolean var2) throws InfoPaneException {
      int var4 = ((Vector)this).size();
      String var5 = var1.GetName();

      for(int var3 = 0; var3 < var4; ++var3) {
         InfoPaneItem var6 = (InfoPaneItem)((Vector)this).elementAt(var3);
         int var7 = var5.compareTo(var6.GetName());
         if (var7 == 0) {
            if (var2) {
               ((Vector)this).removeElementAt(var3);
               ((Vector)this).insertElementAt(var1, var3);
               return var1;
            }

            throw new InfoPaneException("Attempt to add duplicate!\n\tInfoPaneVector already contains an item named \"" + var5 + "\"!");
         }

         if (var7 < 0) {
            ((Vector)this).insertElementAt(var1, var3);
            return var1;
         }
      }

      ((Vector)this).insertElementAt(var1, var4);
      return var1;
   }

   void Sort() throws InfoPaneException {
      for(boolean var1 = false; !var1; var1 = this.Sort1()) {
      }

   }

   boolean Sort1() throws InfoPaneException {
      ((Vector)this).elements();
      int var2 = ((Vector)this).size();

      for(int var1 = 0; var1 < var2 - 1; ++var1) {
         InfoPaneItem var3 = (InfoPaneItem)((Vector)this).elementAt(var1);
         InfoPaneItem var4 = (InfoPaneItem)((Vector)this).elementAt(var1 + 1);
         if (var3.GetName().compareTo(var4.GetName()) > 0) {
            ((Vector)this).removeElementAt(var1);
            this.Insert(var3);
            return false;
         }
      }

      return true;
   }

   void Read(String var1, Class var2) {
      try {
         FileInputStream var3 = new FileInputStream(var1);
         ObjectInputStream var4 = new ObjectInputStream(var3);

         Object var5;
         while((var5 = var4.readObject()) != null) {
            InfoPane.AssertClass(var5, var2);
            this.Insert((InfoPaneItem)var5);
         }

         var3.close();
      } catch (EOFException var6) {
      } catch (Exception var7) {
         System.out.println("InfoPaneVector.Read: " + var7);
      }
   }

   void Write(String var1, Class var2) {
      try {
         FileOutputStream var3 = new FileOutputStream(var1);
         ObjectOutputStream var4 = new ObjectOutputStream(var3);
         int var6 = ((Vector)this).size();

         for(int var5 = 0; var5 < var6; ++var5) {
            Object var7 = ((Vector)this).elementAt(var5);
            InfoPane.AssertClass(var7, var2);
            var4.writeObject(var7);
         }

         var4.flush();
         var3.close();
      } catch (Exception var8) {
         System.out.println("InfoPaneVector.Write: " + var8);
      }
   }
}
