package lotus.notes.internal;

public class MessageQueue {
   public static final int MQSCAN_NOERROR = 0;
   public static final int MQSCAN_ABORT = 1;
   public static final int MQSCAN_DEQUEUE = 2;
   public static final int MQSCAN_DELETE = 3;
   public static final int NOERROR = 0;
   public static final int MQ_WAIT_FOR_MSG = 1;
   public static final int MQ_OVERRIDE_QUIT = 2;
   public static final int MQ_SUPPRESS_DUPLICATES = 1;
   public static final int MQ_CLOSE_ONLYIFEMPTY = 1;
   private int mMessageQueue;
   private StringBuffer mMessageBuffer = new StringBuffer();
   private boolean mbOpen = false;

   public void finalize() {
      if (this.mbOpen) {
         this.close(0);
      }

   }

   public int create(String var1, int var2, int var3) {
      int var4 = 0;
      var4 = this.NCreate(var1, var2, var3);
      return var4;
   }

   public int open(String var1, int var2) {
      int var3 = 0;
      var3 = this.NOpen(var1, var2);
      this.mbOpen = var3 == 0;
      return var3;
   }

   public int close(int var1) {
      int var2 = 0;
      var2 = this.NClose(this.mMessageQueue, var1);
      this.mbOpen = false;
      return var2;
   }

   public int put(int var1, String var2, int var3, int var4, int var5) {
      int var6 = 0;
      var6 = this.NPut(this.mMessageQueue, var1, var2, var3, var4, var5);
      return var6;
   }

   public int get(StringBuffer var1, int var2, int var3, int var4) {
      int var5 = 0;
      var1.setLength(0);
      var5 = this.NGet(this.mMessageQueue, var2, var3, var4);
      if (var5 == 0) {
         var1.append(this.mMessageBuffer);
      }

      return var5;
   }

   public int getRefCount() {
      int var1 = 0;
      var1 = this.NGetRefCount(this.mMessageQueue);
      return var1;
   }

   public int scan(StringBuffer var1, int var2, int var3, MessageQueueCBObject var4) {
      int var5 = 0;
      var1.setLength(0);
      if (var4 != null) {
         var5 = this.NScan(this.mMessageQueue, var2, var3, var4);
         if (var5 == 0) {
            var1.append(this.mMessageBuffer);
         }
      }

      return var5;
   }

   public void putQuitMsg() {
      this.NPutQuitMessage(this.mMessageQueue);
   }

   public boolean isQuitPending() {
      return this.NIsQuitPending(this.mMessageQueue);
   }

   public int getCount() {
      return this.NGetCount(this.mMessageQueue);
   }

   private void setMessageQueue(int var1) {
      this.mMessageQueue = var1;
   }

   private void setMessageBuffer(String var1) {
      this.mMessageBuffer.setLength(0);
      this.mMessageBuffer.append(var1);
   }

   private native int NCreate(String var1, int var2, int var3);

   private native int NOpen(String var1, int var2);

   private native int NClose(int var1, int var2);

   private native int NPut(int var1, int var2, String var3, int var4, int var5, int var6);

   private native int NGet(int var1, int var2, int var3, int var4);

   private native int NGetRefCount(int var1);

   private native int NPutQuitMessage(int var1);

   private native boolean NIsQuitPending(int var1);

   private native int NGetCount(int var1);

   private native int NScan(int var1, int var2, int var3, MessageQueueCBObject var4);
}
