package lotus.notes.addins.ispy.net.portcheck;

import java.util.EventObject;

public class PortCheckEvent extends EventObject {
   public PortCheckStatus status = new PortCheckStatus();
   public String message = "";
   public long openMillis = System.currentTimeMillis();
   public long closeMillis;
   public String[] transactions;

   public PortCheckEvent(PortCheck var1, String[] var2) {
      super(var1);
      this.closeMillis = this.openMillis;
      if (var2 != null) {
         this.transactions = new String[var2.length];
      }

   }

   public static PortCheckEvent getTimeout(PortCheck var0, long var1, int var3) {
      PortCheckEvent var4 = new PortCheckEvent(var0, (String[])null);
      var4.status.bitset.set(1);
      var4.message = "MailSpy timeout of " + Integer.toString(var3) + "ms exceeded.";
      var4.openMillis = var1;
      var4.closeMillis = var1 + (long)var3;
      return var4;
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer(80);
      PortCheck var2 = (PortCheck)((EventObject)this).getSource();
      var1.append(var2.getServiceName());
      var1.append('\t');
      var1.append(var2.getServiceAbbreviation());
      var1.append('\t');
      var1.append(Integer.toString(var2.getPort()));
      var1.append('\t');
      var1.append(this.status.toString());
      var1.append('\t');
      var1.append(this.message);
      var1.append('\t');
      var1.append(Long.toString(this.openMillis));
      var1.append('\t');
      var1.append(Long.toString(this.closeMillis));
      return var1.toString();
   }
}
