package lotus.notes.internal;

import java.io.EOFException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.StringTokenizer;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import lotus.notes.JavaString;

public class InfoPane {
   private static InfoPaneRootItem rootItem;
   static final String indexFilePath = "lotus/notes/internal/INFOPANE";
   // $FF: synthetic field
   static Class class$lotus$notes$internal$InfoPaneTopItem;

   InfoPane() {
      rootItem = null;
   }

   public static void main(String[] var0) {
      new JavaString("lotus.notes.AgentResources");
      GetRootItem();
      if (var0.length > 0) {
         rootItem.Print("", true);
      } else {
         rootItem.Print("", false);
      }

      System.exit(0);
   }

   static InfoPaneRootItem GetRootItem() {
      if (rootItem == null) {
         Initialize();
      }

      return rootItem;
   }

   static void Initialize() {
      try {
         rootItem = new InfoPaneRootItem();
         String var0 = System.getProperty("java.class.path");
         String var1 = System.getProperty("path.separator", ";");
         StringTokenizer var2 = new StringTokenizer(var0, var1);

         while(var2.hasMoreTokens()) {
            String var3 = var2.nextToken();
            if (!var3.endsWith(".jar") && !var3.endsWith(".zip")) {
               try {
                  FileInputStream var9 = new FileInputStream(var3 + "/" + "lotus/notes/internal/INFOPANE");
                  ReadIndexFile(var9);
               } catch (FileNotFoundException var6) {
               }
            } else {
               try {
                  ZipFile var4 = new ZipFile(var3);
                  ZipEntry var5 = var4.getEntry("lotus/notes/internal/INFOPANE");
                  if (var5 != null) {
                     ReadIndexFile(var4.getInputStream(var5));
                  }
               } catch (IOException var7) {
               }
            }
         }

      } catch (Exception var8) {
         System.out.println("InfoPane.Initialize exception: " + var8);
         ((Throwable)var8).printStackTrace();
      }
   }

   static void ReadIndexFile(InputStream var0) {
      try {
         ObjectInputStream var1 = new ObjectInputStream(var0);

         Object var2;
         try {
            while((var2 = var1.readObject()) != null) {
               AssertClass(var2, class$lotus$notes$internal$InfoPaneTopItem != null ? class$lotus$notes$internal$InfoPaneTopItem : (class$lotus$notes$internal$InfoPaneTopItem = class$("lotus.notes.internal.InfoPaneTopItem")));
               InfoPaneTopItem var3 = (InfoPaneTopItem)var2;
               InfoPaneTopItem var4 = rootItem.FindItem(var3.name);
               if (var4 == null) {
                  rootItem.AddItem(var3);
               }
            }
         } catch (EOFException var5) {
         }

         var0.close();
      } catch (Exception var6) {
         System.out.println("InfoPane.ReadIndexFile exception: " + var6);
         ((Throwable)var6).printStackTrace();
      }
   }

   static void AssertClass(Object var0, Class var1) throws InfoPaneException {
      if (var0.getClass() != var1) {
         throw new InfoPaneException("\nClass mismatch: Expected " + var1 + ",\n\t\tactual " + var0.getClass());
      }
   }

   // $FF: synthetic method
   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError(((Throwable)var2).getMessage());
      }
   }
}
